function FirstInterface
clearvars
clear all;
screensize = get( groot, 'Screensize' );
ProgramWidth = 1300;
ProgramHeight = 650;
ScrWidth = screensize(3);
ScrHeight = screensize(4);
ScreenXPos = (ScrWidth/2)- (ProgramWidth/2);
ScreenYPos = (ScrHeight/2)- (ProgramHeight/2);
ScreenXPosTrue = (ScrWidth/2);
ScreenYPosTrue = (ScrHeight/2);

currentFolder = pwd;
addpath(genpath(strcat(pwd,'/Functions/')));

% Colors
global buttoncolors;
buttoncolors = [0.98 0.98 0.98];
global Backgroundcolor;
Backgroundcolor = [1 1 1];

global ProgramName;
ProgramName = 'CARRE Multiparametric Scales Data Analyzer';
h=figure('Color',Backgroundcolor,'MenuBar','none','Name',ProgramName,'NumberTitle','off','Position',[ScreenXPos ScreenYPos ProgramWidth ProgramHeight],'ReSize','off');
%set(h,'CloseRequestFcn',@closeMain);
%% Global variables
global DATA;
global DATA_PP;
global DATA_PP_MAIN;
global BACKUP_DATA;
global DATA_Time;
global header;
% Axes Y
global axes_aukstis;
axes_aukstis = 100;
global axes_height;
axes_height = axes_aukstis + 10;
global xposition;
xposition = -1172;
xpositiontrue = -1172;
global axesatstumasytextdim;
% Axes X
global Signal_Time;
global Time_Diff;
Time_Diff = 8;
global SliderVal;
SliderVal = 100;
global SliderVal2;
SliderVal2 = 1;
global SliderValAF;
SliderValAF = 50;

% Calculations
global filenamec;
global filename;
global pathname;
global Frequ8;
global ZeroI;
global ZeroQ;
global RchI;
global RchQ;
global Real_Q;
global Real_I;
global AF; % Artrial fibrilation
AF = 0;

global Z;
global Fi;

global CBox;
CBox(1) = 0;CBox(2) = 0;CBox(3) = 0;CBox(4) = 0;CBox(5) = 0;CBox(6) = 0;
CBox(7) = 0;CBox(8) = 0;CBox(9) = 0;CBox(10) = 0;CBox(11) = 0;CBox(12) = 0;CBox(13) = 0;
CBox(14) = 0;CBox(15) = 0;CBox(16) = 0;

global CBoxPP;
CBoxPP(1) = 0;CBoxPP(2) = 0;CBoxPP(3) = 0;CBoxPP(4) = 0;CBoxPP(5) = 0;CBoxPP(6) = 0;
CBoxPP(7) = 0;CBoxPP(8) = 0;CBoxPP(9) = 0;CBoxPP(10) = 0;

% Analysis
global Fs;
global PRADZIA;
global EKG_CH1;
global EKG_CH2;
global EKG_CH3;
global DATA_ECG_CH1_NEXT;
global DATA_ETAPAS;
global DATA_ECG_CH2_NEXT;
global DATA_ECG_CH3_NEXT;
global AFE_I;
global RH;
global ETAPAS;
global ECG;
global AFE_Q;
global ADS_IPG;
global data2;
global Labeltrue;
global BestECGSignal;
global PAT_SSF;
global RRI;
global HRCycleAF;
global PEPtime;
PEPtime = 70;
global ECGRRCheckRes;

% RR
global rrRR;
global DATA_ECG_CH1_RR;
global DATA_ECG_CH2_RR;
global DATA_ECG_CH3_RR;
global UsedsignalRR;
global RRAnalysisSignal;
global ECG_SIGNAL_USED;
ECG_SIGNAL_USED = DATA_ECG_CH1_NEXT;
Labeltrue = {'SYNC';'RESPIRATION';'ECG LEAD I';'ECG LEAD II';'ECG LEAD III';'IPG FOOT';'IPG PALM';'IPG PALM AMPLIFIED';'Temperature';'Humidity'};

% AF Analysis globals
global rIndex;
global R;
global Rthr;
global minRthrsize;

% Safety
global fidnr;
fidnr = 0;
global zoomcheck;
zoomcheck = 0;
global FileOpened;
FileOpened = 0;

% Patient Parameters
global PatientName;
global Weight;
global Height;
global Age;
global Sex;
global Sexnr;

% Patient variables
global Pattextfontsize;
global Pattextx;
global Pattexty;
global Pattextxans;
global Pattextxbuttons;
global Paticonycorr;

% Signal Compare variables
global maxComp;
global minComp;
global CompareSignal1;
global CompareSignal2;
global CompareSignal3;
CompareSignal1 = 4;
CompareSignal2 = 5;
CompareSignal3 = 6;
global SliderValComp2;
SliderValComp2 = 10;
global SliderValComp3;
global SliderValComp4;
SliderValComp3 = 1;
SliderValComp4 = 1;
global XSliderTick;
XSliderTick = 10;

Pattextfontsize = 8;
Pattextx = 20;
Pattexty = 660;
global Pattextyres;
Pattextyres = 470;
Pattextxans = 60;
Pattextxbuttons = 200;
Paticonycorr = 0;
PattextxRes = 0;
global BCARESX;
BCARESX = 10;
global BCARESX1;
BCARESX1 = 130;

% BIVA vars
global Female50X;
global Female75X;
global Female95X;
global Female50Y;
global Female75Y;
global Female95Y;
global Male50X;
global Male75X;
global Male95X;
global Male50Y;
global Male75Y;
global Male95Y;
global Resistance1;
global Reactance1;
global BivaState;
BivaState = 2;

% BC Par
global FM1;
FM1 = 8;
global FM2;
FM2 = 20;
global FFM1;
FFM1 = 80;
global FFM2;
FFM2 = 92;
global BMI;
global FM;
global Resistance;
global Reactance;
global Impedance;
global MedianPAT;
global MeanPAT;
global STDPAT;

% BC Report
global BMR;
global FatMassPr;
global FatFMassPr;
global TBW;
global TBWPrFFM;
global TBWPrTW;
global ECWPrTBW;
global ICWPrTBW;
global MMass;
global MMassPrW;
global RDEE;
global xpie;
global Other;
global labelspie;

% HRV var
global sMeanRR;
global sSTDHR;
global sMeanHR;
global sSTDRR;
global sRMSSD;
global sNN50;
global spNN50;
global HR2;
global rr;
global speedpat1;
global speedpat2;
global speedpat;

% Saved data
global weightSavedDATA;
global BMISavedDATA;
global FMSavedDATA;
global ResistanceSavedDATA;
global ReactanceSavedDATA;
global MedianPATSavedDATA;
global MeanPATSavedDATA;
global STDPATSavedDATA;
global DateSavedDATA;
global MeasureDate;

% Other
global APStatus;
APStatus = 0;
global skew1;
global skew2;
global skew3;
global checkBCA;
global checkECG;
checkBCA = 0;
checkECG = 0;

%% Menubar
Menuh1 = uimenu(h,'Label','File');
Menuh11 = uimenu(Menuh1,'Label','Open','Callback', @hOpenMenuitemCallback);
Menuh12 = uimenu(Menuh1,'Label','Generate Report','Callback', @hReportitemCallback);
Menuh2 = uimenu(h,'Label','View');
Menuh21 = uimenu(Menuh2,'Label','File Info','ForegroundColor',[0.5 0.5 0.5]);
Menuh22 = uimenu(Menuh2,'Label','Signal compare','ForegroundColor',[0.5 0.5 0.5]);
Menuh23 = uimenu(Menuh2,'Label','View Historical Analysis','Callback', @hViewData);
Menuh3 = uimenu(h,'Label','Save');
Menuh31 = uimenu(Menuh3,'Label','Save Current Parameters','Callback', @hSaveData);
Menuh4 = uimenu(h,'Label','About');

%% Panels
Axispanel = uipanel('Units','pixels','Position',[10, 10, ProgramWidth-20-200, ProgramHeight-20],'BackGroundColor',Backgroundcolor);
AxispanelSlider = uipanel('Parent',Axispanel,'Units','pixels','Position',[0, xposition, ProgramWidth-200-20, 1800],'BackGroundColor',Backgroundcolor);
Axispanelaxes = uipanel('Parent',Axispanel,'Units','pixels','Position',[0, 20, ProgramWidth-200-20, 23],'BackGroundColor',Backgroundcolor);

uicontrol('Parent',Axispanelaxes,'Style','text','TooltipString','Date','HorizontalAlignment','left','FontWeight','normal','String','Time, s','FontSize',10,'Units','Pixels','Position',[1000 -3 60 20],'BackGroundColor',Backgroundcolor);


%% SaveData window
SaveParametersData=figure('Color',[1 1 1],'MenuBar','none','Name','Save Parameters','NumberTitle','off','Position',[500 500 400 300],'ReSize','off');

uicontrol('Parent',SaveParametersData,'Style','text','TooltipString','Name','HorizontalAlignment','left','FontWeight','bold','String','Name - ','FontSize',10,'Units','Pixels','Position',[20 250 80 20],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',SaveParametersData,'Style','text','TooltipString','Date','HorizontalAlignment','left','FontWeight','bold','String','Date - ','FontSize',10,'Units','Pixels','Position',[230 250 100 20],'BackGroundColor',Backgroundcolor);

ButtonSaveDataParameters=uicontrol('Parent',SaveParametersData,'Style','pushbutton','String','Save','FontWeight','bold','FontSize',10,'Units','pixels','Position',[200, 15, 130, 40],'BackGroundColor',Backgroundcolor);
set(ButtonSaveDataParameters,'Callback',@ButtonSaveDataParametersCallback);

set(SaveParametersData,'Visible','off');
set(SaveParametersData,'CloseRequestFcn',@closeSaveParametersData,'Interruptible','off');

%% ViewData window
SavedData=figure('Color',[1 1 1],'MenuBar','none','Name','Historical Analysis','NumberTitle','off','Position',[500 500 800 450],'ReSize','off');
SavedDataaxis = axes('Parent',SavedData,'Units','pixels','Position', [60, 50, 600, 310],'FontSize',8);
PoPUpSavedData=uicontrol('Parent',SavedData,'Style','popupmenu','String',{'Weight','BMI','Fat Mass','Resistance','Reactance','MedianPAT','MeanPAT','STDPAT'},'Units','Pixels','Position',[670 270 120 20],'BackGroundColor',Backgroundcolor);
set(PoPUpSavedData,'Callback',@PoPUpSavedDataCallback);
set(SavedData,'Visible','off');
set(SavedData,'CloseRequestFcn',@closeSavedData,'Interruptible','off');

%% Analysis 1 window
graphfontsize = 5;
ASwindowheight = 650;
Analysis1=figure('Color',Backgroundcolor,'MenuBar','none','Name','Arterial Stiffness Analysis','NumberTitle','off','Position',[ScreenXPos+10 ScreenYPos-100 1070 ASwindowheight],'ReSize','off');
set(Analysis1,'Visible','off');
axan1 = axes ('Parent',Analysis1,'Units','pixels','Position', [50, ASwindowheight-150, 750, 120],'FontSize',graphfontsize);
axan2 = axes ('Parent',Analysis1,'Units','pixels','Position', [50, ASwindowheight-310, 750, 120],'FontSize',graphfontsize);
ASECGSigText = uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','','Units','Pixels','FontSize',13,'Position',[800, ASwindowheight-400, 200, 20],'BackGroundColor',Backgroundcolor);

PoPUpW1=uicontrol('Parent',Analysis1,'Style','popupmenu','ToolTipString','Choose Graph','String',{'EKG Lead I','EKG Lead II','EKG Lead III'},'Units','Pixels','Position',[855 ASwindowheight-130 130 18],'BackGroundColor',Backgroundcolor);
set(PoPUpW1,'Callback',@PCallback1,'Interruptible','off');
set(Analysis1,'CloseRequestFcn',@closeAnalysis1,'Interruptible','off');

TextAS1 = uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','Best quality ECG signal:','Units','Pixels','Position',[855 ASwindowheight-80 200 18],'BackGroundColor',Backgroundcolor);
TextAS2 = uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','bold','FontSize',9,'String','','Units','Pixels','Position',[855 ASwindowheight-100 200 18],'BackGroundColor',Backgroundcolor);
TextAS3 = uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','bold','FontSize',9,'String','','Units','Pixels','Position',[855 ASwindowheight-220 200 18],'BackGroundColor',Backgroundcolor);

uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','Mean PAT:','Units','Pixels','Position',[835 ASwindowheight-250 200 18],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','Median PAT:','Units','Pixels','Position',[835 ASwindowheight-280 200 18],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','STD PAT:','Units','Pixels','Position',[835 ASwindowheight-310 200 18],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','Pulse Wave Velocity:','Units','Pixels','Position',[835 ASwindowheight-340 200 18],'BackGroundColor',Backgroundcolor);

uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','ms','Units','Pixels','Position',[900 ASwindowheight-265 200 18],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','ms','Units','Pixels','Position',[900 ASwindowheight-295 200 18],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','ms','Units','Pixels','Position',[900 ASwindowheight-325 200 18],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','m/s','Units','Pixels','Position',[920 ASwindowheight-355 200 18],'BackGroundColor',Backgroundcolor);

uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','Age:','Units','Pixels','Position',[835 ASwindowheight-160 30 18],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','years','Units','Pixels','Position',[925 ASwindowheight-160 40 18],'BackGroundColor',Backgroundcolor);
ASAge = uicontrol('Parent',Analysis1,'Style','edit','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','','Units','Pixels','Position',[880 ASwindowheight-160 40 18],'BackGroundColor',Backgroundcolor);
set(ASAge,'Callback',@TBASAgeCallback);

uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','Height:','Units','Pixels','Position',[835 ASwindowheight-180 40 18],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','cm','Units','Pixels','Position',[925 ASwindowheight-180 40 18],'BackGroundColor',Backgroundcolor);
ASHeight = uicontrol('Parent',Analysis1,'Style','edit','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','','Units','Pixels','Position',[880 ASwindowheight-180 40 18],'BackGroundColor',Backgroundcolor);
set(ASHeight,'Callback',@TBASHeightCallback);

uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','TooltipString','Pre-ejection Period','FontWeight','normal','FontSize',9,'String','PEP:','Units','Pixels','Position',[835 ASwindowheight-200 40 18],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','TooltipString','Pre-ejection Period','FontWeight','normal','FontSize',9,'String','ms','Units','Pixels','Position',[925 ASwindowheight-200 40 18],'BackGroundColor',Backgroundcolor);
ASPEP = uicontrol('Parent',Analysis1,'Style','edit','HorizontalAlignment','left','FontWeight','normal','FontSize',9,'String','','Units','Pixels','Position',[880 ASwindowheight-200 40 18],'BackGroundColor',Backgroundcolor);
set(ASPEP,'Callback',@TBASPEPCallback);

%axPWV = axes('Parent',Analysis1,'Units','pixels', 'Position', [102,37,610,256],'Visible', 'on','FontSize',graphfontsize+3);

%% Analysis 2 window
Analysis2=figure('Color',Backgroundcolor,'MenuBar','none','Name','Atrial Fibrilation Analysis','NumberTitle','off','Position',[ScreenXPos+10 ScreenYPos+10 1000 550],'ReSize','off');
axan11 = axes ('Parent',Analysis2,'Units','pixels','Position', [60, 150, 750, 350],'FontSize',graphfontsize);
% axan21 = axes ('Parent',Analysis2,'Units','pixels','Position', [60, 270, 750, 110],'FontSize',graphfontsize);
% axan31 = axes ('Parent',Analysis2,'Units','pixels','Position', [60, 390, 750, 110],'FontSize',graphfontsize);
axan22 = axes ('Parent',Analysis2,'Units','pixels','Position', [60, 35, 750, 60],'FontSize',graphfontsize);
set(Analysis2,'Visible','off');
set(Analysis2,'CloseRequestFcn',@closeAnalysis2);

SliderAF=uicontrol('Parent',Analysis2,'Style','slider','Units','pixels','Max',100,'Min',0,'Value',50,'SliderStep',[0.01 0.02],'Position',[45 110 770 20],'BackGroundColor',Backgroundcolor);
hListenerAF = addlistener(SliderAF,'ContinuousValueChange',@SLCallbackAF);
setappdata(SliderAF,'sliderListener',hListenerAF);


Text1 = uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','bold','FontSize',12,'String','Atrial fibrilation Detection','Units','Pixels','Position',[50, 520, 200, 20],'BackGroundColor',Backgroundcolor);

uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','bold','FontSize',14,'String','I','Units','Pixels','Position',[25, 440, 20, 20],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','bold','FontSize',14,'String','II','Units','Pixels','Position',[22, 320, 20, 20],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','bold','FontSize',14,'String','III','Units','Pixels','Position',[20, 190, 20, 20],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',8,'String','AF','Units','Pixels','Position',[30, 70, 20, 20],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','normal','FontSize',8,'String','non AF','Units','Pixels','Position',[10, 30, 40, 20],'BackGroundColor',Backgroundcolor);

uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Mean HR:','Units','Pixels','FontSize',11,'Position',[830, 370, 200, 20],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Max HR:','Units','Pixels','FontSize',11,'Position',[830, 350, 200, 20],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Min HR:','Units','Pixels','FontSize',11,'Position',[830, 330, 200, 20],'BackGroundColor',Backgroundcolor);
AFResult1 = uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','FontSize',11,'Position',[900, 370, 200, 20],'BackGroundColor',Backgroundcolor);
AFResult2 = uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','FontSize',11,'Position',[900, 350, 200, 20],'BackGroundColor',Backgroundcolor);
AFResult3 = uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','FontSize',11,'Position',[900, 330, 200, 20],'BackGroundColor',Backgroundcolor);

AFResultText = uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','','Units','Pixels','FontSize',13,'Position',[850, 150, 200, 20],'BackGroundColor',Backgroundcolor);

ButtonAF=uicontrol('Parent',Analysis2,'Style','text','String','','FontWeight','bold','FontSize',10,'Units','pixels','Position',[830, 40, 130, 40],'BackGroundColor',Backgroundcolor);

% hZoomInPushtool = uipushtool('Parent',hToolbar1,'TooltipString','Zoom In','CData',icon3,'HandleVisibility','callback','ClickedCallback', @hZoomInMenuitemCallback);
% hZoomOutPushtool = uipushtool('Parent',hToolbar1,'TooltipString','Zoom Out','CData',icon4,'HandleVisibility','callback','ClickedCallback', @hZoomOutMenuitemCallback);

%% SigComp Window

Comp1Y = 70;
Comp2Y = 340;
SigCompare=figure('Color',Backgroundcolor,'MenuBar','none','Name','Signal Compare','NumberTitle','off','Position',[200 300 1000 600],'ReSize','off');
axcomp1 = axes ('Parent',SigCompare,'Units','pixels','Color', 'none','Position', [30, Comp1Y, 700, 250],'FontSize',graphfontsize);
axcomp2 = axes ('Parent',SigCompare,'Units','pixels','Color', 'none','Position', [30, Comp2Y, 700, 250],'FontSize',graphfontsize);
set(SigCompare,'Visible', 'off');
set(SigCompare,'CloseRequestFcn',@closeSigCompare);

%% BCA Window
BCA=figure('Color',Backgroundcolor,'MenuBar','none','Name','Body Composition Analysis','NumberTitle','off','Position',[ScreenXPos+10 ScreenYPos+10 1000 700],'ReSize','off');
set(BCA,'CloseRequestFcn',@closeParameters);

%     FATBMI = uipanel('Parent',BCA,'Units','pixels','Position',[300, 200, 300, 100],'BackGroundColor',[1 1 1],'BorderWidth',3,'HighlightColor',[0.5 0.5 0.5]);

PatInfo11 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Name:','FontSize',Pattextfontsize+4,'Units','Pixels','Position',[Pattextx Pattexty 70 20],'BackGroundColor',Backgroundcolor);
PatInfo22 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Weight:','FontSize',Pattextfontsize+4,'Units','Pixels','Position',[Pattextx Pattexty-30 70 20],'BackGroundColor',Backgroundcolor);
PatInfo33 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Height:','FontSize',Pattextfontsize+4,'Units','Pixels','Position',[Pattextx Pattexty-60 70 20],'BackGroundColor',Backgroundcolor);
PatInfo44 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Age:','FontSize',Pattextfontsize+4,'Units','Pixels','Position',[Pattextx Pattexty-90 70 20],'BackGroundColor',Backgroundcolor);
PatInfo55 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Sex:','FontSize',Pattextfontsize+4,'Units','Pixels','Position',[Pattextx Pattexty-120 70 20],'BackGroundColor',Backgroundcolor);

uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Body Composition Parameters:','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[Pattextx+PattextxRes Pattextyres+30 300 20],'BackGroundColor',Backgroundcolor);

PatRes11 = uicontrol('Parent',BCA,'Style','text','TooltipString','Body Mass Index','HorizontalAlignment','left','FontWeight','bold','String','Body Mass Index:','FontSize',Pattextfontsize+2,'Units','Pixels','Position',[Pattextx+PattextxRes Pattextyres 200 20],'BackGroundColor',Backgroundcolor);
PatRes22 = uicontrol('Parent',BCA,'Style','text','TooltipString','Basal Metabolic Rate','HorizontalAlignment','left','FontWeight','bold','String','Basal Metabolic Rate:','FontSize',Pattextfontsize+2,'Units','Pixels','Position',[Pattextx+PattextxRes Pattextyres-40 200 20],'BackGroundColor',Backgroundcolor);
PatRes33 = uicontrol('Parent',BCA,'Style','text','TooltipString','Fat mass, %','HorizontalAlignment','left','FontWeight','bold','String','Fat Mass:','FontSize',Pattextfontsize+2,'Units','Pixels','Position',[Pattextx+PattextxRes Pattextyres-80 200 20],'BackGroundColor',Backgroundcolor);
PatRes44 = uicontrol('Parent',BCA,'Style','text','TooltipString','Fat Free mass, %','HorizontalAlignment','left','FontWeight','bold','String','Fat Free Mass:','FontSize',Pattextfontsize+2,'Units','Pixels','Position',[Pattextx+PattextxRes Pattextyres-120 200 20],'BackGroundColor',Backgroundcolor);

PatResult11 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','normal','String','-','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[Pattextx+BCARESX Pattextyres-20 120 20],'BackGroundColor',Backgroundcolor);
PatResult22 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','normal','String','-','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[Pattextx+BCARESX Pattextyres-60 120 20],'BackGroundColor',Backgroundcolor);
PatResult33 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','normal','String','-','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[Pattextx+BCARESX Pattextyres-100 120 20],'BackGroundColor',Backgroundcolor);
PatResult44 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','normal','String','-','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[Pattextx+BCARESX Pattextyres-140 120 20],'BackGroundColor',Backgroundcolor);

uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','20.0 - 25.0','FontSize',Pattextfontsize+1,'Units','Pixels','Position',[Pattextx+BCARESX1 Pattextyres-20 100 20],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','1395 - 1782','FontSize',Pattextfontsize+1,'Units','Pixels','Position',[Pattextx+BCARESX1 Pattextyres-60 100 20],'BackGroundColor',Backgroundcolor);
FatMass1 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','8 - 20 %','FontSize',Pattextfontsize+1,'Units','Pixels','Position',[Pattextx+BCARESX1 Pattextyres-100 100 20],'BackGroundColor',Backgroundcolor);
FatFreeMass1 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','80 - 92 %','FontSize',Pattextfontsize+1,'Units','Pixels','Position',[Pattextx+BCARESX1 Pattextyres-140 100 20],'BackGroundColor',Backgroundcolor);

PatRes211 = uicontrol('Parent',BCA,'Style','text','TooltipString','Total Body Water Mass','HorizontalAlignment','left','FontWeight','bold','String','TBW Mass:','FontSize',Pattextfontsize+2,'Units','Pixels','Position',[Pattextx+PattextxRes Pattextyres-160 200 20],'BackGroundColor',Backgroundcolor);
PatRes222 = uicontrol('Parent',BCA,'Style','text','TooltipString','Total Body water % of Fat Free Mass','HorizontalAlignment','left','FontWeight','bold','String','TBW % of FFM:','FontSize',Pattextfontsize+2,'Units','Pixels','Position',[Pattextx+PattextxRes Pattextyres-200 200 20],'BackGroundColor',Backgroundcolor);
PatRes233 = uicontrol('Parent',BCA,'Style','text','TooltipString','Total Body Water % of Total Weight','HorizontalAlignment','left','FontWeight','bold','String','TBW % of Total Weight:','FontSize',Pattextfontsize+2,'Units','Pixels','Position',[Pattextx+PattextxRes Pattextyres-240 200 20],'BackGroundColor',Backgroundcolor);
PatRes244 = uicontrol('Parent',BCA,'Style','text','TooltipString','Extracellular water % of Total body water','HorizontalAlignment','left','FontWeight','bold','String','ECW % of TBW:','FontSize',Pattextfontsize+2,'Units','Pixels','Position',[Pattextx+PattextxRes Pattextyres-280 200 20],'BackGroundColor',Backgroundcolor);
PatRes255 = uicontrol('Parent',BCA,'Style','text','TooltipString','Intracellular water % of Total body water','HorizontalAlignment','left','FontWeight','bold','String','ICW % of TBW:','FontSize',Pattextfontsize+2,'Units','Pixels','Position',[Pattextx+PattextxRes Pattextyres-320 200 20],'BackGroundColor',Backgroundcolor);

PatResult211 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','normal','String','-','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[Pattextx+BCARESX Pattextyres-180 120 20],'BackGroundColor',Backgroundcolor);
PatResult222 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','normal','String','-','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[Pattextx+BCARESX Pattextyres-220 120 20],'BackGroundColor',Backgroundcolor);
PatResult233 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','normal','String','-','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[Pattextx+BCARESX Pattextyres-260 120 20],'BackGroundColor',Backgroundcolor);
PatResult244 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','normal','String','-','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[Pattextx+BCARESX Pattextyres-300 120 20],'BackGroundColor',Backgroundcolor);
PatResult255 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','normal','String','-','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[Pattextx+BCARESX Pattextyres-340 120 20],'BackGroundColor',Backgroundcolor);

uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','37.9 - 52.9 kg','FontSize',Pattextfontsize+1,'Units','Pixels','Position',[Pattextx+BCARESX1 Pattextyres-180 100 20],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','73.6 - 75.2 %','FontSize',Pattextfontsize+1,'Units','Pixels','Position',[Pattextx+BCARESX1 Pattextyres-220 100 20],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','51.4 - 61.0 %','FontSize',Pattextfontsize+1,'Units','Pixels','Position',[Pattextx+BCARESX1 Pattextyres-260 100 20],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','57.6 - 60.4 %','FontSize',Pattextfontsize+1,'Units','Pixels','Position',[Pattextx+BCARESX1 Pattextyres-300 100 20],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','39.6 - 42.4 %','FontSize',Pattextfontsize+1,'Units','Pixels','Position',[Pattextx+BCARESX1 Pattextyres-340 100 20],'BackGroundColor',Backgroundcolor);

PatRes311 = uicontrol('Parent',BCA,'Style','text','TooltipString','Muscle Mass','HorizontalAlignment','left','FontWeight','bold','String','Muscle Mass:','FontSize',Pattextfontsize+2,'Units','Pixels','Position',[Pattextx+PattextxRes Pattextyres-360 200 20],'BackGroundColor',Backgroundcolor);
PatRes322 = uicontrol('Parent',BCA,'Style','text','TooltipString','Muscle Mass % of Weight','HorizontalAlignment','left','FontWeight','bold','String','Muscle Mass % of Weight:','FontSize',Pattextfontsize+2,'Units','Pixels','Position',[Pattextx+PattextxRes Pattextyres-400 200 20],'BackGroundColor',Backgroundcolor);
PatRes333 = uicontrol('Parent',BCA,'Style','text','TooltipString','Resting Daily Energy Expenditure','HorizontalAlignment','left','FontWeight','bold','String','RDEE:','FontSize',Pattextfontsize+2,'Units','Pixels','Position',[Pattextx+PattextxRes Pattextyres-440 200 20],'BackGroundColor',Backgroundcolor);

PatResult311 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','normal','String','-','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[Pattextx+BCARESX Pattextyres-380 120 20],'BackGroundColor',Backgroundcolor);
PatResult322 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','normal','String','-','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[Pattextx+BCARESX Pattextyres-420 120 20],'BackGroundColor',Backgroundcolor);
PatResult333 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','normal','String','-','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[Pattextx+BCARESX Pattextyres-460 120 20],'BackGroundColor',Backgroundcolor);

BIVAaxis = axes ('Parent',BCA,'Units','pixels','Position', [300, 50, 300, 300],'FontSize',graphfontsize);
BIVAaxis.XLabel.String = 'Reactance';
BIVAaxis.YLabel.String = 'Resistance';
BIVAPie = axes ('Parent',BCA,'Units','pixels','Position', [600, 100, 400, 300],'FontSize',graphfontsize);
set(BIVAPie,'Visible','off');
uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Bioelectrical impedance vector analysis (BIVA)','FontSize',Pattextfontsize+4,'Units','Pixels','Position',[320 370 320 20],'BackGroundColor',Backgroundcolor);
BC = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Body Composition Chart','FontSize',Pattextfontsize+4,'Units','Pixels','Position',[700 370 320 20],'BackGroundColor',Backgroundcolor);

uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Body Mass Index','FontSize',Pattextfontsize+4,'Units','Pixels','Position',[560 500 320 20],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Body Fat, %','FontSize',Pattextfontsize+4,'Units','Pixels','Position',[580 600 320 20],'BackGroundColor',Backgroundcolor);

uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Body Composition Analysis','FontSize',Pattextfontsize+6,'Units','Pixels','Position',[450 640 320 25],'BackGroundColor',Backgroundcolor);

BCAlert = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Insert all the information','FontSize',Pattextfontsize+4,'Units','Pixels','Position',[700 150 320 20],'BackGroundColor',Backgroundcolor,'ForeGroundColor',[1,0,0]);

set(BC,'Visible','off');

Param1 = axes ('Parent',BCA,'Units','pixels','Position', [300, 450, 600, 30]);
Param1.YTick = '';
Param1.YColor = [1 1 1];
Param1.XLim = [8 55];


Param2 = axes ('Parent',BCA,'Units','pixels','Position', [300, 550, 600, 30]);
Param2.YTick = '';
Param2.YColor = [1 1 1];
Param2.XLim = [0 50];

set(BCA,'Visible','off');

FatUnder = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','bold','String','Underfat','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[300 570 150 20],'BackGroundColor',[0.9,0.9,1]);
FatHealt = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','bold','String','Healthy','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[450 570 150 20],'BackGroundColor',[0.9,1,0.9]);
FatOverf = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','bold','String','Overfat','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[600 570 150 20],'BackGroundColor',[1,0.9,0.9]);
FatObese = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','bold','String','Obese','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[750 570 150 20],'BackGroundColor',[1,0.8,0.8]);

PoPUpBIVAEdit=uicontrol('Parent',BCA,'Style','popupmenu','String',{'Arm-Leg','Legs'},'Units','Pixels','Position',[500 60 120 20],'BackGroundColor',Backgroundcolor);
set(PoPUpBIVAEdit,'Callback',@PoPUpBIVACallback);

ButtonAP=uicontrol('Parent',BCA,'Style','pushbutton','String','^^^ Advanced Parameters','FontWeight','bold','FontSize',10,'Units','pixels','Position',[800 2 200 50],'BackGroundColor',Backgroundcolor);
set(ButtonAP,'Callback',@BAPCallback);

AdvancedParametersPanel = uipanel('Parent',BCA,'Units','pixels','Position',[0, 54, 1000, 350],'BackGroundColor',Backgroundcolor);
set(AdvancedParametersPanel,'Visible','off');

%% HRV Window
HRVFigure=figure('Color',[1 1 1],'MenuBar','none','Name','Heart Rate Variability Analysis','NumberTitle','off','Position',[ScreenXPos+10 ScreenYPos+10 800 600],'ReSize','off');
set(HRVFigure,'CloseRequestFcn',@closeHRV);
set(HRVFigure,'Visible','off');

uicontrol('Parent',HRVFigure,'Style','text','HorizontalAlignment','center','FontWeight','bold','String','Parameters:','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[80 515 150 20],'BackGroundColor',[1,1,1]);
uicontrol('Parent',HRVFigure,'Style','text','HorizontalAlignment','center','FontWeight','bold','String','Time Domain Analysis:','FontSize',Pattextfontsize+5,'Units','Pixels','Position',[40 545 250 20],'BackGroundColor',[1,1,1]);
uicontrol('Parent',HRVFigure,'Style','text','HorizontalAlignment','center','FontWeight','bold','String','Poincar plot:','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[340 550 250 20],'BackGroundColor',[1,1,1]);
% uicontrol('Parent',HRVFigure,'Style','text','HorizontalAlignment','center','FontWeight','bold','String','Frequency Domain Analysis:','FontSize',Pattextfontsize+5,'Units','Pixels','Position',[650 545 250 20],'BackGroundColor',[1,1,1]);

uicontrol('Parent',HRVFigure,'Style','text','HorizontalAlignment','center','FontWeight','bold','String','Distributions:','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[80 280 150 20],'BackGroundColor',[1,1,1]);
axhrv1 = axes ('Parent',HRVFigure,'Units','pixels','Position', [50,50,200,220],'FontSize',graphfontsize);
axhrv2 = axes ('Parent',HRVFigure,'Units','pixels','Position', [300,50,200,220],'FontSize',graphfontsize);
axhrv3 = axes ('Parent',HRVFigure,'Units','pixels','Position', [550,50,200,220],'FontSize',graphfontsize);
axhrv4 = axes ('Parent',HRVFigure,'Units','pixels','Position', [350,320,300,220],'FontSize',graphfontsize);

HRVParam = {'Mean RR' sMeanRR  'ms';...
    'STD RR' sSTDRR  'ms';...
    'Mean HR' sMeanHR  '1/min';
    'STD HR' sSTDRR  '1/min';
    'RMSSD' sRMSSD  'ms';
    'NN50' sNN50  '';
    'pNN50' spNN50  '%';};


cnames1 = {'Variable','Value','Units'};
Table1 = uitable(HRVFigure,'Data',HRVParam,'ColumnName',cnames1,'RowName',[]);
Table1.Position(3) = Table1.Extent(3);
Table1.Position(4) = Table1.Extent(4);
Table1.Position(1) = 50;
Table1.Position(2) = 360;

%% Report window
PageHeight = 700;
PageWidth = 500;
PrintFile=figure('Color',[1 1 1],'MenuBar','none','Name','Form PDF','NumberTitle','off','Position',[200 30 PageWidth PageHeight],'ReSize','off');
set(PrintFile,'CloseRequestFcn',@closePrintFile);
set(PrintFile,'Visible','off');


uicontrol('Parent',PrintFile,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','CARRE Multiparametric Scales Report','Units','Pixels','FontSize',8,'Position',[100,670,300,15],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','center');
uicontrol('Parent',PrintFile,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Biomedical Engineering Intitute','Units','Pixels','FontSize',6,'Position',[100,655,300,15],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','center');
uicontrol('Parent',PrintFile,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Kaunas University of Technology','Units','Pixels','FontSize',6,'Position',[100,645,300,15],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','center');

uicontrol('Parent',PrintFile,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Recording Date:','Units','Pixels','FontSize',6,'Position',[30,655,70,15],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',PrintFile,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Recording length (s):','Units','Pixels','FontSize',6,'Position',[380,655,100,15],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','right');

% Patient Info
global panel1height;
panel1height = 50;

PatientInfo = uipanel('Parent',PrintFile,'Units','pixels','Position',[10 590 480 panel1height],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',PatientInfo,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Patient Name:','Units','Pixels','FontSize',6,'Position',[10,panel1height-15,80,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',PatientInfo,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Age:','Units','Pixels','FontSize',6,'Position',[10,panel1height-25,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',PatientInfo,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Sex:','Units','Pixels','FontSize',6,'Position',[140,panel1height-25,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',PatientInfo,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Weight:','Units','Pixels','FontSize',6,'Position',[10,panel1height-35,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',PatientInfo,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Height:','Units','Pixels','FontSize',6,'Position',[140,panel1height-35,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');



% Heart Analysis results
global panel2height;
panel2height = 230;
uicontrol('Parent',PrintFile,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Heart Functions Analysis','Units','Pixels','FontSize',8,'Position',[30 578,200,12],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

HeartAnalysisResults = uipanel('Parent',PrintFile,'Units','pixels','Position',[10 345 480 panel2height],'BackGroundColor',Backgroundcolor);
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Total Beats:','Units','Pixels','FontSize',6,'Position',[10,panel2height-15,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Mean HR:','Units','Pixels','FontSize',6,'Position',[10,panel2height-25,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Median HR:','Units','Pixels','FontSize',6,'Position',[10,panel2height-35,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Max HR:','Units','Pixels','FontSize',6,'Position',[10,panel2height-45,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Min HR:','Units','Pixels','FontSize',6,'Position',[10,panel2height-55,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','RMSSD:','Units','Pixels','FontSize',6,'Position',[160,panel2height-15,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','NN50:','Units','Pixels','FontSize',6,'Position',[160,panel2height-25,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','pNN50:','Units','Pixels','FontSize',6,'Position',[160,panel2height-35,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','STDRR:','Units','Pixels','FontSize',6,'Position',[160,panel2height-45,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','STDHR:','Units','Pixels','FontSize',6,'Position',[160,panel2height-55,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Mean PAT:','Units','Pixels','FontSize',6,'Position',[300,panel2height-15,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Median PAT:','Units','Pixels','FontSize',6,'Position',[300,panel2height-25,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','STD PAT:','Units','Pixels','FontSize',6,'Position',[300,panel2height-35,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Blood Velocity:','Units','Pixels','FontSize',6,'Position',[300,panel2height-45,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
%uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','STDHR:','Units','Pixels','FontSize',6,'Position',[220,panel2height-55,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

%Units
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Beats','Units','Pixels','FontSize',6,'Position',[100,panel2height-15,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Beats/min','Units','Pixels','FontSize',6,'Position',[100,panel2height-25,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Beats/min','Units','Pixels','FontSize',6,'Position',[100,panel2height-35,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Beats/min','Units','Pixels','FontSize',6,'Position',[100,panel2height-45,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Beats/min:','Units','Pixels','FontSize',6,'Position',[100,panel2height-55,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ms','Units','Pixels','FontSize',6,'Position',[260,panel2height-15,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','%','Units','Pixels','FontSize',6,'Position',[260,panel2height-25,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','%','Units','Pixels','FontSize',6,'Position',[260,panel2height-35,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ms','Units','Pixels','FontSize',6,'Position',[260,panel2height-45,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Beats','Units','Pixels','FontSize',6,'Position',[260,panel2height-55,25,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ms','Units','Pixels','FontSize',6,'Position',[400,panel2height-15,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ms','Units','Pixels','FontSize',6,'Position',[400,panel2height-25,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ms','Units','Pixels','FontSize',6,'Position',[400,panel2height-35,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','m/s','Units','Pixels','FontSize',6,'Position',[400,panel2height-45,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Distribution charts:','Units','Pixels','FontSize',6,'Position',[30,panel2height-65,200,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');



% Axes
HRReportaxes1 = axes ('Parent',HeartAnalysisResults,'Units','pixels','Position', [20,panel2height-170,120,100],'FontSize',graphfontsize);
HRReportaxes2 = axes ('Parent',HeartAnalysisResults,'Units','pixels','Position', [170,panel2height-170,120,100],'FontSize',graphfontsize);
HRReportaxes3 = axes ('Parent',HeartAnalysisResults,'Units','pixels','Position', [340,panel2height-170,120,100],'FontSize',graphfontsize);

uicontrol('Parent',HeartAnalysisResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','AF Detection __________','Units','Pixels','FontSize',8,'Position',[30,panel2height-220,300,12],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');



% BC Analysis results
global panel3height;
panel3height = 200;
uicontrol('Parent',PrintFile,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Body Composition Analysis','Units','Pixels','FontSize',8,'Position',[30 333,200,12],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

BodyCompResults = uipanel('Parent',PrintFile,'Units','pixels','Position',[10 130 480 panel3height],'BackGroundColor',Backgroundcolor);

uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Body Mass Index:','Units','Pixels','FontSize',6,'Position',[10,panel3height-15,90,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Basal Metabolic Rate:','Units','Pixels','FontSize',6,'Position',[10,panel3height-25,90,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Fat Mass:','Units','Pixels','FontSize',6,'Position',[10,panel3height-35,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Fat Free Mass:','Units','Pixels','FontSize',6,'Position',[10,panel3height-45,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','TBW Mass:','Units','Pixels','FontSize',6,'Position',[160,panel3height-15,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','TBW % of FFM:','Units','Pixels','FontSize',6,'Position',[160,panel3height-25,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','TBW % of TW:','Units','Pixels','FontSize',6,'Position',[160,panel3height-35,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ECW % of TBW:','Units','Pixels','FontSize',6,'Position',[160,panel3height-45,70,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ICW % of TBW:','Units','Pixels','FontSize',6,'Position',[300,panel3height-15,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Muscle Mass:','Units','Pixels','FontSize',6,'Position',[300,panel3height-25,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Muscle Mass % of weight:','Units','Pixels','FontSize',6,'Position',[300,panel3height-35,110,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','RDEE:','Units','Pixels','FontSize',6,'Position',[300,panel3height-45,60,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

% Units
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','FontSize',6,'Position',[135,panel3height-15,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','kcal','Units','Pixels','FontSize',6,'Position',[135,panel3height-25,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','%','Units','Pixels','FontSize',6,'Position',[135,panel3height-35,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','%','Units','Pixels','FontSize',6,'Position',[135,panel3height-45,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','kg','Units','Pixels','FontSize',6,'Position',[275,panel3height-15,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','%','Units','Pixels','FontSize',6,'Position',[275,panel3height-25,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','%','Units','Pixels','FontSize',6,'Position',[275,panel3height-35,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','%','Units','Pixels','FontSize',6,'Position',[275,panel3height-45,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','%','Units','Pixels','FontSize',6,'Position',[445,panel3height-15,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','kg','Units','Pixels','FontSize',6,'Position',[445,panel3height-25,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','%','Units','Pixels','FontSize',6,'Position',[445,panel3height-35,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','kcal','Units','Pixels','FontSize',6,'Position',[445,panel3height-45,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Body Composition Chart:','Units','Pixels','FontSize',6,'Position',[20,panel3height-60,170,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','BIVA Chart:','Units','Pixels','FontSize',6,'Position',[190,panel3height-60,200,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Resistance:','Units','Pixels','FontSize',6,'Position',[340,panel3height-70,80,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Reactance:','Units','Pixels','FontSize',6,'Position',[340,panel3height-80,80,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Impedance:','Units','Pixels','FontSize',6,'Position',[340,panel3height-90,80,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Ohm','Units','Pixels','FontSize',6,'Position',[440,panel3height-70,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Ohm','Units','Pixels','FontSize',6,'Position',[440,panel3height-80,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Ohm','Units','Pixels','FontSize',6,'Position',[440,panel3height-90,20,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');

% Axes

BCReportaxes1 = axes ('Parent',BodyCompResults,'Units','pixels','Position', [20,panel3height-175,120,100],'FontSize',graphfontsize);
BCReportaxes2 = axes ('Parent',BodyCompResults,'Units','pixels','Position', [170,panel3height-170,120,100],'FontSize',graphfontsize);


uicontrol('Parent',PrintFile,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Generated:','Units','Pixels','FontSize',6,'Position',[300,30,300,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');


%% Axis
graphfontsize = 5;
axesatstumasx = 40;
panel_height = 1800;
axes_ilgis = ProgramWidth-200-20-150;
axesatstumasxtext = 980;
axesatstumasytext = -50;
axesatstumasytextdim = -30;
ax1Resp = axes ('Parent',AxispanelSlider,'Units','pixels','Position', [axesatstumasx, panel_height - (1 * axes_height), axes_ilgis, axes_aukstis],'FontSize',graphfontsize);

ax(1) = axes ('Parent',AxispanelSlider,'Units','pixels','Position', [axesatstumasx, panel_height - (1 * axes_height), axes_ilgis, axes_aukstis],'FontSize',graphfontsize);
ax(2) = axes ('Parent',AxispanelSlider,'Units','pixels','Position', [axesatstumasx, panel_height - (2 * axes_height), axes_ilgis, axes_aukstis],'FontSize',graphfontsize);
ax(3) = axes ('Parent',AxispanelSlider,'Units','pixels','Position', [axesatstumasx, panel_height - (3 * axes_height), axes_ilgis, axes_aukstis],'FontSize',graphfontsize);
ax(4) = axes ('Parent',AxispanelSlider,'Units','pixels','Position', [axesatstumasx, panel_height - (4 * axes_height), axes_ilgis, axes_aukstis],'FontSize',graphfontsize);
ax(5) = axes ('Parent',AxispanelSlider,'Units','pixels','Position', [axesatstumasx, panel_height - (5 * axes_height), axes_ilgis, axes_aukstis],'FontSize',graphfontsize);
ax(6) = axes ('Parent',AxispanelSlider,'Units','pixels','Position', [axesatstumasx, panel_height - (6 * axes_height), axes_ilgis, axes_aukstis],'FontSize',graphfontsize);
ax(7) = axes ('Parent',AxispanelSlider,'Units','pixels','Position', [axesatstumasx, panel_height - (7 * axes_height), axes_ilgis, axes_aukstis],'FontSize',graphfontsize);
ax(8) = axes ('Parent',AxispanelSlider,'Units','pixels','Position', [axesatstumasx, panel_height - (8 * axes_height), axes_ilgis, axes_aukstis],'FontSize',graphfontsize);
ax(9) = axes ('Parent',AxispanelSlider,'Units','pixels','Position', [axesatstumasx, panel_height - (9 * axes_height), axes_ilgis, axes_aukstis],'FontSize',graphfontsize);
ax(10) = axes ('Parent',AxispanelSlider,'Units','pixels','Position', [axesatstumasx, panel_height - (10 * axes_height), axes_ilgis, axes_aukstis],'FontSize',graphfontsize);

for i= 1:1:10
    ax(i).XTick = '';
    ax(i).XColor = [1 1 1];
end
set(ax,'Visible','off');
set(ax1Resp,'Visible','off');
axaxes = axes ('Parent',Axispanelaxes,'Units','pixels','Position', [axesatstumasx, 22, axes_ilgis, 50]);
axaxes.YTick = '';
axaxes.YColor = [1 1 1];

SignalText(1) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','SYNC','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (1 * axes_height)-axesatstumasytext, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalText(2) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','RESPIRATION','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (2 * axes_height)-axesatstumasytext, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalText(3) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ECG Lead I','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (3 * axes_height)-axesatstumasytext, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalText(4) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ECG Lead II','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (4 * axes_height)-axesatstumasytext, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalText(5) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ECG Lead III','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (5 * axes_height)-axesatstumasytext, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalText(6) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','IPG FOOT','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (6 * axes_height)-axesatstumasytext, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalText(7) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','IPG PALM','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (7 * axes_height)-axesatstumasytext, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalText(8) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','IPG PALM AMPLIFIED','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (8 * axes_height)-axesatstumasytext, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalText(9) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Temperature','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (9 * axes_height)-axesatstumasytext, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalText(10) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Humidity, %','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (10 * axes_height)-axesatstumasytext, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);

SignalDim(1) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (1 * axes_height)-axesatstumasytextdim, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalDim(2) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (2 * axes_height)-axesatstumasytextdim, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalDim(3) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (3 * axes_height)-axesatstumasytextdim, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalDim(4) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (4 * axes_height)-axesatstumasytextdim, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalDim(5) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (5 * axes_height)-axesatstumasytextdim, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalDim(6) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (6 * axes_height)-axesatstumasytextdim, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalDim(7) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (7 * axes_height)-axesatstumasytextdim, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalDim(8) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (8 * axes_height)-axesatstumasytextdim, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalDim(9) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (9 * axes_height)-axesatstumasytextdim, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);
SignalDim(10) = uicontrol('Parent',AxispanelSlider,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','Position',[axesatstumasxtext-5, panel_height - (10 * axes_height)-axesatstumasytextdim, axes_ilgis, 20],'BackGroundColor',Backgroundcolor);

set(SignalText,'Visible','off');
set(SignalDim,'Visible','off');

%% Texts

FileName = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','File Name:','Units','Pixels','Position',[1115, 620, 80, 20],'BackGroundColor',Backgroundcolor);
FileNameRes = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','---','Units','Pixels','Position',[1195, 620, 150, 20],'BackGroundColor',Backgroundcolor);

PatientName = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Patient Name:','Units','Pixels','Position',[1115, 602, 80, 20],'BackGroundColor',Backgroundcolor);
PatientNamechange=uicontrol('Parent',h,'Style','pushbutton','String','Change Name','FontWeight','bold','FontSize',9,'Units','pixels','Position',[1135, 565, 120, 20],'BackGroundColor',Backgroundcolor);
set(PatientNamechange,'Callback',@PatientNamechangeCallback);

PatientNameRes = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','---','Units','Pixels','Position',[1115, 585, 150, 20],'BackGroundColor',Backgroundcolor);
PatientNameResEdit = uicontrol('Parent',h,'Style','edit','HorizontalAlignment','left','FontWeight','bold','String','---','Units','Pixels','Position',[1115, 585, 150, 20],'BackGroundColor',Backgroundcolor);
set(PatientNameResEdit,'Callback',@TBCallbackPatientNameResEdit);
set(PatientNameResEdit,'Visible','off');

%% Checkboxes

CBxstart = 560;
CBystart = 1115;
CBatstumas = 20;

CheckBoxW1=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBystart, CBxstart, 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxW1,'Callback',@CHCallback1);
CheckBoxW2=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBystart, CBxstart-(CBatstumas*1), 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxW2,'Callback',@CHCallback2);
CheckBoxW3=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBystart, CBxstart-(CBatstumas*2), 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxW3,'Callback',@CHCallback3);
CheckBoxW4=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBystart, CBxstart-(CBatstumas*3), 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxW4,'Callback',@CHCallback4);
CheckBoxW5=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBystart, CBxstart-(CBatstumas*4), 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxW5,'Callback',@CHCallback5);
CheckBoxW6=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBystart, CBxstart-(CBatstumas*5), 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxW6,'Callback',@CHCallback6);
CheckBoxW7=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBystart, CBxstart-(CBatstumas*6), 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxW7,'Callback',@CHCallback7);
CheckBoxW8=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBystart, CBxstart-(CBatstumas*7), 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxW8,'Callback',@CHCallback8);
CheckBoxW9=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBystart, CBxstart-(CBatstumas*8), 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxW9,'Callback',@CHCallback9);
CheckBoxW10=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBystart, CBxstart-(CBatstumas*9), 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxW10,'Callback',@CHCallback10);

set(CheckBoxW1,'Visible','off');
%set(CheckBoxW2,'Visible','off');
checkboxdisable();

%% CBTexts
CBytextstart = CBystart +20;

tcb1 = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','SYNC','Units','Pixels','Position',[CBytextstart, CBxstart, 100, 15],'BackGroundColor',Backgroundcolor);
tcb2 = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','RESPIRATION','Units','Pixels','Position',[CBytextstart, CBxstart-(CBatstumas*1), 100, 15],'BackGroundColor',Backgroundcolor);
tcb3 = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ECG LEAD I','Units','Pixels','Position',[CBytextstart, CBxstart-(CBatstumas*2), 100, 15],'BackGroundColor',Backgroundcolor);
tcb4 = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ECG LEAD II','Units','Pixels','Position',[CBytextstart, CBxstart-(CBatstumas*3), 100, 15],'BackGroundColor',Backgroundcolor);
tcb5 = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ECG LEAD III','Units','Pixels','Position',[CBytextstart, CBxstart-(CBatstumas*4), 100, 15],'BackGroundColor',Backgroundcolor);
tcb6 = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','IPG FOOT','Units','Pixels','Position',[CBytextstart, CBxstart-(CBatstumas*5), 100, 15],'BackGroundColor',Backgroundcolor);
tcb7 = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','IPG PALM','Units','Pixels','Position',[CBytextstart, CBxstart-(CBatstumas*6), 100, 15],'BackGroundColor',Backgroundcolor);
tcb8 = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','IPG PALM AMPLIFIED','Units','Pixels','Position',[CBytextstart, CBxstart-(CBatstumas*7), 150, 15],'BackGroundColor',Backgroundcolor);
tcb9 = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Temperature','Units','Pixels','Position',[CBytextstart, CBxstart-(CBatstumas*8), 100, 15],'BackGroundColor',Backgroundcolor);
tcb10 = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Humidity','Units','Pixels','Position',[CBytextstart, CBxstart-(CBatstumas*9), 100, 15],'BackGroundColor',Backgroundcolor);
set(tcb1,'Visible','off');
%set(tcb2,'Visible','off');

%% PP Checkboxes

CBPPxstart = CBxstart - 40;
CBPPystart = 1255;
CBPPatstumas = 20;

PPTextRAW = uicontrol('Parent',h,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Not Filtered','Units','Pixels','Position',[CBPPystart-25, CBPPxstart+20, 100, 15],'BackGroundColor',Backgroundcolor);

CheckBoxPPW1=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBPPystart, CBPPxstart, 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxPPW1,'Callback',@CHPPCallback1);
set(CheckBoxPPW1,'Enable','off');
CheckBoxPPW2=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBPPystart, CBPPxstart-(CBPPatstumas*1), 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxPPW2,'Callback',@CHPPCallback2);
set(CheckBoxPPW2,'Enable','off');
CheckBoxPPW3=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBPPystart, CBPPxstart-(CBPPatstumas*2), 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxPPW3,'Callback',@CHPPCallback3);
set(CheckBoxPPW3,'Enable','off');
CheckBoxPPW4=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBPPystart, CBPPxstart-(CBPPatstumas*3), 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxPPW4,'Callback',@CHPPCallback4);
set(CheckBoxPPW4,'Enable','off');
CheckBoxPPW5=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBPPystart, CBPPxstart-(CBPPatstumas*4), 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxPPW5,'Callback',@CHPPCallback5);
set(CheckBoxPPW5,'Enable','off');
CheckBoxPPW6=uicontrol('Parent',h,'Style','checkbox','Units','pixels','Position',[CBPPystart, CBPPxstart-(CBPPatstumas*5), 20, 20],'BackGroundColor',Backgroundcolor);
set(CheckBoxPPW6,'Callback',@CHPPCallback6);
set(CheckBoxPPW6,'Enable','off');

%% Sliders
SliderS1=uicontrol('Parent',Axispanel,'Style','slider','Units','pixels','Max',500,'Min',0,'Value',100,'SliderStep',[0.01 0.02],'Position',[0 0 ProgramWidth-25-200 20],'BackGroundColor',Backgroundcolor);
hListenerS1 = addlistener(SliderS1,'ContinuousValueChange',@SLCallback1);
setappdata(SliderS1,'sliderListener',hListenerS1);
set(SliderS1,'Enable','off');

SliderS2=uicontrol('Parent',h,'Style','slider','Units','pixels','Max',500,'Min',0,'Value',500,'SliderStep',[0.01 0.02],'Position',[1089 54 20 585],'BackGroundColor',Backgroundcolor);
hListenerS2 = addlistener(SliderS2,'ContinuousValueChange',@SLCallback2);
setappdata(SliderS2,'sliderListener',hListenerS2);
set(SliderS2,'Enable','off');
%% Buttons
Button1=uicontrol('Parent',h,'Style','pushbutton','String','-','FontWeight','normal','FontSize',25,'Units','pixels','Position',[1230 140 50 50],'BackGroundColor',buttoncolors);
set(Button1,'Callback',@B1Callback);
Button2=uicontrol('Parent',h,'Style','pushbutton','String','+','FontWeight','normal','FontSize',25,'Units','pixels','Position',[1130 140 50 50],'BackGroundColor',buttoncolors);
set(Button2,'Callback',@B2Callback);

Button3=uicontrol('Parent',h,'Style','pushbutton','String','-','FontWeight','normal','FontSize',25,'Units','pixels','Position',[1180 90 50 50],'BackGroundColor',buttoncolors);
set(Button3,'Callback',@B3Callback);
Button4=uicontrol('Parent',h,'Style','pushbutton','String','+','FontWeight','normal','FontSize',25,'Units','pixels','Position',[1180 190 50 50],'BackGroundColor',buttoncolors);
set(Button4,'Callback',@B4Callback);

ctrlbuttondisable();

ButtonOpenFile=uicontrol('Parent',h,'Style','pushbutton','String','Open File','ForegroundColor',[0.5 0.5 0.5],'FontWeight','normal','FontSize',20,'Units','pixels','Position',[510 320 150 50],'BackGroundColor',buttoncolors);
set(ButtonOpenFile,'Callback',@hOpenMenuitemCallback);

Button5=uicontrol('Parent',h,'Style','pushbutton','String','Arterial Stiffness','FontWeight','normal','FontSize',8,'Units','pixels','Position',[1120 340 170 30],'BackGroundColor',buttoncolors);
set(Button5,'Callback',@B5Callback);
Button6=uicontrol('Parent',h,'Style','pushbutton','String','Body Composition','FontWeight','normal','FontSize',8,'Units','pixels','Position',[1120 250 170 30],'BackGroundColor',buttoncolors);
set(Button6,'Callback',@B6Callback);

Button7=uicontrol('Parent',h,'Style','pushbutton','String','Atrial Fibrilation','FontWeight','normal','FontSize',8,'Units','pixels','Position',[1120 310 170 30],'BackGroundColor',buttoncolors);
set(Button7,'Callback',@B7Callback);


Button8=uicontrol('Parent',h,'Style','pushbutton','String','HR Variability','FontWeight','normal','FontSize',8,'Units','pixels','Position',[1120 280 170 30],'BackGroundColor',buttoncolors);
set(Button8,'Callback',@B8Callback);


%% Error


%% Images
image1 = axes('Parent',h,'Units','pixels', 'Position', [1130,-20,80,135],'Visible', 'on');
axes(image1)

matlabImage = imread(strcat(pwd,'/Pictures/biomedicina_small.jpg'));
image(matlabImage)
axis off
axis image
image2 = axes('Parent',h,'Units','pixels', 'Position', [1210,-25,65,135],'Visible', 'on');
axes(image2)
matlabImage = imread(strcat(pwd,'/Pictures/CARREpic.jpg'));
image(matlabImage)
axis off
axis image

image3 = axes('Parent',Analysis2,'Units','pixels', 'Position', [870,75,60,60],'Visible', 'on');

image4 = axes('Parent',Analysis1,'Units','pixels', 'Position', [20,ASwindowheight-620,800,270],'Visible', 'on');

axPWV = axes('Parent',Analysis1,'Units','pixels', 'Position', [102,ASwindowheight-613,610,256],'Visible', 'on','FontSize',graphfontsize+1);

%% Functions
    function hOpenMenuitemCallback(hObject, eventdata)
        if fidnr == 1
            fclose('all');
        end
        clear filenamec pathname;
        [filename, pathname] = uigetfile('*.GDF', 'Pasirinkti Byla','','MultiSelect', 'off');
        set(ButtonOpenFile,'Visible','off');
        if pathname == 0
            disp('Atsaukta');
            set(ButtonOpenFile,'Visible','on');
            return;
        end
        % Nuskaitoma irasymo data
        v = pathname;
        C = strsplit(v,'\');
        s = length(C);
        irasymodata = C(s-1);
        irasymodata = irasymodata{1,1};
        Year = {irasymodata(1:4)};
        Month = {irasymodata(5:6)};
        Day = {irasymodata(7:8)};
        MeasureDate = strcat(Year,'-',Month,'-',Day);
        MeasureDate = MeasureDate{1,1};
        
        
        clearvars DATA DATA_PP DATA_PP_MAIN;
        
        set(CheckBoxW1,'Value',0);
        set(CheckBoxW2,'Value',0);
        set(CheckBoxW3,'Value',1);
        set(CheckBoxW4,'Value',1);
        set(CheckBoxW5,'Value',1);
        set(CheckBoxW6,'Value',1);
        set(CheckBoxW7,'Value',0);
        set(CheckBoxW8,'Value',0);
        set(CheckBoxW9,'Value',0);
        set(CheckBoxW10,'Value',0);
        
        set(CheckBoxPPW1,'Enable','on');
        set(CheckBoxPPW2,'Enable','on');
        set(CheckBoxPPW3,'Enable','on');
        set(CheckBoxPPW4,'Enable','on');
        
        %CB reset
        CBox(1) = 0;CBox(2) = 0;CBox(3) = 1;CBox(4) = 1;CBox(5) = 1;CBox(6) = 1;
        CBox(7) = 0;CBox(8) = 0;CBox(9) = 0;CBox(10) = 0;CBox(11) = 0;CBox(12) = 0;CBox(13) = 0;
        CBox(14) = 0;CBox(15) = 0;CBox(16) = 0;
        
        %
        filenamec = filename;
        
        
        %DATA = sload(filename);
        [DATA,header] = sload([pathname filename],0,'OVERFLOWDETECTION','Off');
        DATA = DATA(2200:end,1:10);
        BACKUP_DATA = DATA;
        DATA_SYNC = DATA(: ,1);
        DATA_ETAPAS = DATA(: ,2);
        DATA_ECG_CH1_RR = DATA(: ,3);
        DATA_ECG_CH2_RR = DATA(: ,4);
        DATA_ECG_CH3_RR = DATA(: ,5);
        DATA_ECG_CH1_NEXT = DATA(: ,3);
        DATA_ECG_CH2_NEXT = DATA(: ,4);
        DATA_ECG_CH3_NEXT = DATA(: ,5);
        DATA_ADS_IPG = DATA(: ,6);
        DATA_AFE_I = DATA(: ,7);
        DATA_AFE_Q = DATA(: ,8);
        DATA_Temperature = DATA(: ,9);
        DATA_RH = DATA(: ,10);
        
        % RR Resp
        [BestSigNr, pol]=  SkewnessAnalysis();
        if BestSigNr == 1;
            RRAnalysisSignal = DATA(: ,3);
        elseif BestSigNr == 2;
            RRAnalysisSignal = DATA(: ,4);
        else
            RRAnalysisSignal = DATA(: ,5);
        end
        % Irasomas geriausias ecg signalas
        BestECGSignal = BestSigNr;
        
        if pol == 1;
            UsedsignalRR = RRAnalysisSignal;
        else
            UsedsignalRR = -RRAnalysisSignal;
            
        end
        
        % ECG Filtering for main screen
        %     [DATA_ECG_CH1, delayECG1]=fun_ECG_processing_v2_noplot(DATA(: ,3), 500);
        %     [DATA_ECG_CH2, delayECG2]=fun_ECG_processing_v2_noplot(DATA(: ,4), 500);
        %     [DATA_ECG_CH3, delayECG3]=fun_ECG_processing_v2_noplot(DATA(: ,5), 500);
        
        DATA_ECG_CH1=ECGfilterCARRE(DATA(: ,3), 0.6,20);
        DATA_ECG_CH2=ECGfilterCARRE(DATA(: ,4), 0.6,20);
        DATA_ECG_CH3=ECGfilterCARRE(DATA(: ,5), 0.6,20);
        
        [IPG1, delayIPG1]=fun_IPG_differentiator_noplot_p(DATA_ADS_IPG, 250);
        [IPG2, delayIPG2]=fun_IPG_differentiator_noplot_p(DATA_AFE_I, 250);
        [IPG3, delayIPG3]=fun_IPG_differentiator_noplot_p(DATA_AFE_Q, 250);
        
        Length_Signal_True = length(DATA_SYNC);
        %    delays = [delayECG1 delayECG2 delayECG3];
        %     max_delay = max(delays);
        
        %     ilgis1 = length(DATA_ECG_CH1);
        %     ilgis2 = length(DATA_ECG_CH2);
        %     ilgis3 = length(DATA_ECG_CH3);
        ipglength1 = length(IPG1);
        ipglength2 = length(IPG1);
        ipglength3 = length(IPG1);
        %     del1 = Length_Signal_True - ilgis1;
        %     del2 = Length_Signal_True - ilgis2;
        %     del3 = Length_Signal_True - ilgis3;
        del4 = Length_Signal_True - ipglength1;
        del5 = Length_Signal_True - ipglength2;
        del6 = Length_Signal_True - ipglength3;
        %
        %     ECG_PP1 = [DATA_ECG_CH1; zeros(del1,1)];
        %     ECG_PP2 = [DATA_ECG_CH2; zeros(del2,1)];
        %     ECG_PP3 = [DATA_ECG_CH3; zeros(del3,1)];
        %     DATA_PP(: ,3) = ECG_PP1;
        %     DATA_PP(: ,4) = ECG_PP2;
        %     DATA_PP(: ,5) = ECG_PP3;
        %
        DATA_PP(: ,3) = DATA_ECG_CH1;
        DATA_PP(: ,4) = DATA_ECG_CH2;
        DATA_PP(: ,5) = DATA_ECG_CH3;
        
        IPG1 = [IPG1; zeros(del4,1)];
        IPG2 = [IPG2; zeros(del5,1)];
        IPG3 = [IPG3; zeros(del6,1)];
        DATA_PP(: ,6) = -IPG1;
        DATA_PP(: ,7) = -IPG2;
        DATA_PP(: ,8) = -IPG3;
        DATA_PP_MAIN(: ,6) = -IPG1;
        DATA_PP_MAIN(: ,7) = -IPG2;
        DATA_PP_MAIN(: ,8) = -IPG3;
        
        DATA_PP(: ,9) = DATA_Temperature(1:Length_Signal_True);
        DATA_PP(: ,10) = DATA_RH(1:Length_Signal_True);
        
        DATA_PP_MAIN(: ,9) = DATA_Temperature(1:Length_Signal_True);
        DATA_PP_MAIN(: ,10) = DATA_RH(1:Length_Signal_True);
        
        lp = 40;
        hp = 0.67;
        
        DATA_PP_MAIN(: ,3) = ECGfilterCARRE(DATA(: ,3), lp, hp);
        DATA_PP_MAIN(: ,4) = ECGfilterCARRE(DATA(: ,4), lp, hp);
        DATA_PP_MAIN(: ,5) = ECGfilterCARRE(DATA(: ,5), lp, hp);
        
        % Getting Patient information from header file
        
        set(FileNameRes,'String',filename);
        % Irasomas Vardas
        if isempty(header.Patient.Name)
            PatientName = 'Unknown';
           % PatientName = 'Daivaras Sokas';
            set(PatientNameRes,'String',PatientName);
            
        else
            set(PatientNameRes,'String',header.Patient.Name);
            PatientName = header.Patient.Name;
        end
        % Irasomas Ugis
        if isempty(header.Patient.Height) || isnan(header.Patient.Height)
            Height = 0;
        else
            Height = header.Patient.Height;
        end
        %% 2016.09.15 SauliusD
        % Irasomas Amzius
        if isempty(header.Patient.Birthday(1)) || isnan(header.Patient.Birthday(1))
            Age = 0;
        else
            b = clock;
            Age     = b(1) - header.Patient.Birthday(1);
            clear b;
        end
        %% end
        
        % Irasoma lytis
        if isempty(header.Patient.Sex) || isnan(header.Patient.Sex)
            Sex = '-';
        else
            if header.Patient.Sex == 1;
                Sex = 'Male';
                Sexnr = header.Patient.Sex;
            else
                Sex = 'Female';
                Sexnr = header.Patient.Sex;
            end
        end
        
        
        
        Signal_Time = length(DATA_SYNC);
        maxtime = Signal_Time/500;
        maxilgis = length(DATA(: ,1));
        DATA_Time = 0:0.002:maxtime-0.002;
        maxilgislaikas = length(DATA_Time);
        PlotGraphs();
        
        b1 = regexp(filenamec,'gdf','split');
        length1 = length(b1{1,1});
        length2 = length(filenamec);
        if length1 == length2
            b1 = regexp(filenamec,'GDF','split');
        end
        
        
        filenamec1 = [pathname, b1{1,1},'txt'];
        
        if exist(filenamec1, 'file')
            ReadTXT();
            
        else
            warningMessage = sprintf('Warning: Text file does not exist:\n%s', filenamec1);
            uiwait(msgbox(warningMessage));
        end
        
        Calculate1();
        
        
        % Spalv keitimai\enable
        
        set(Menuh21,'ForegroundColor',[0 0 0]);
        set(Menuh21,'Callback', @hFileInfoCallback);
        
        set(Menuh22,'ForegroundColor',[0 0 0]);
        set(Menuh22,'Callback', @hSigCompareitemCallback);
        
        % Lo0ad BIV Data
        try
            rawdata=load(strcat(pwd,'/BIVAData/BIVAData'));
        catch
            return;
        end
        %     if filepath == 0
        %       disp('Atsaukta');
        %       return;
        %     end
        FileOpened = 1;
        
        [Female50X] = rawdata.Female50X;
        [Female75X] = rawdata.Female75X;
        [Female95X] = rawdata.Female95X;
        [Female50Y] = rawdata.Female50Y;
        [Female75Y] = rawdata.Female75Y;
        [Female95Y] = rawdata.Female95Y;
        [Male50X] = rawdata.Male50X;
        [Male75X] = rawdata.Male75X;
        [Male95X] = rawdata.Male95X;
        [Male50Y] = rawdata.Male50Y;
        [Male75Y] = rawdata.Male75Y;
        [Male95Y] = rawdata.Male95Y;
        
        %set(h,'Name',strcat(ProgramName,' -- ',filename));
        FileOpened = 1;
        checkboxenable();
        ctrlbuttonenable();
            
        if BestSigNr == 1;
            ECG_SIGNAL_USED = EKG_CH1;
        elseif BestSigNr == 2;
            ECG_SIGNAL_USED = EKG_CH2;
        else
            ECG_SIGNAL_USED = EKG_CH3;
        end
        
        %ECG_SIGNAL_USED = ECGRRCheckRes;
        AnalysisECG();
%         
%         ECGRRQualityCheck();
%             AnalysisECG2First(ECGRRCheckRes);
        HRCycleAF = (60*Fs(2))./(RRI);
        samplerr = length(RRI);
        try
            rrRR = resample(RRI,length(DATA_ETAPAS),samplerr);
        catch
            disp('Signal is corrupted');
        end
        lp = 0.3;
        hp = 0.005;
        
        rrRR = ECGfilterCARRE(rrRR, lp, hp);
        
        
        rr = (RRI*2);
        HR = RRI/500;
        HR2 = 60./HR;
        
        set(SliderS1,'Enable','on');
        set(SliderS2,'Enable','on');
        set(ax1Resp,'Visible','off');
        
    end

    function hReportitemCallback(hObject, eventdata)
        set(PrintFile,'Visible','on');
        
        uicontrol('Parent',PrintFile,'Style','text','HorizontalAlignment','left','FontWeight','normal','String',MeasureDate,'Units','Pixels','FontSize',6,'Position',[10,645,90,15],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','center');
        TimeS = round((Signal_Time-2000)/500,2);
        uicontrol('Parent',PrintFile,'Style','text','HorizontalAlignment','left','FontWeight','normal','String',TimeS,'Units','Pixels','FontSize',6,'Position',[410,645,70,15],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','right');
        
        % Patient info
        uicontrol('Parent',PatientInfo,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',PatientName,'Units','Pixels','FontSize',6,'Position',[100,panel1height-15,150,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',PatientInfo,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',Age,'Units','Pixels','FontSize',6,'Position',[50,panel1height-25,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',PatientInfo,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',Sex,'Units','Pixels','FontSize',6,'Position',[180,panel1height-25,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',PatientInfo,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',Weight,'Units','Pixels','FontSize',6,'Position',[50,panel1height-35,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',PatientInfo,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',Height,'Units','Pixels','FontSize',6,'Position',[180,panel1height-35,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        
        uicontrol('Parent',PatientInfo,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','years','Units','Pixels','FontSize',6,'Position',[70,panel1height-25,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',PatientInfo,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','kg','Units','Pixels','FontSize',6,'Position',[70,panel1height-35,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',PatientInfo,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','cm','Units','Pixels','FontSize',6,'Position',[200,panel1height-35,40,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        
        % Heart Rate
        
        TotalBeats = max(size(HR2));
        MeanHR = mean(HR2);
        MedianHR = median(HR2);
        MinHR = min(HR2);
        MaxHR = max(HR2);
        uicontrol('Parent',HeartAnalysisResults,'Style','text','FontWeight','bold','String',TotalBeats,'Units','Pixels','FontSize',6,'Position',[70,panel2height-15,21,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',HeartAnalysisResults,'Style','text','FontWeight','bold','String',MeanHR,'Units','Pixels','FontSize',6,'Position',[70,panel2height-25,21,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',HeartAnalysisResults,'Style','text','FontWeight','bold','String',MedianHR,'Units','Pixels','FontSize',6,'Position',[70,panel2height-35,21,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',HeartAnalysisResults,'Style','text','FontWeight','bold','String',MaxHR,'Units','Pixels','FontSize',6,'Position',[70,panel2height-45,21,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',HeartAnalysisResults,'Style','text','FontWeight','bold','String',MinHR,'Units','Pixels','FontSize',6,'Position',[70,panel2height-53,21,8],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        
        uicontrol('Parent',HeartAnalysisResults,'Style','text','FontWeight','bold','String',sRMSSD,'Units','Pixels','FontSize',6,'Position',[220,panel2height-15,21,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',HeartAnalysisResults,'Style','text','FontWeight','bold','String',sNN50,'Units','Pixels','FontSize',6,'Position',[220,panel2height-25,21,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',HeartAnalysisResults,'Style','text','FontWeight','bold','String',spNN50,'Units','Pixels','FontSize',6,'Position',[220,panel2height-35,21,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',HeartAnalysisResults,'Style','text','FontWeight','bold','String',sSTDRR,'Units','Pixels','FontSize',6,'Position',[220,panel2height-45,21,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',HeartAnalysisResults,'Style','text','FontWeight','bold','String',sSTDHR,'Units','Pixels','FontSize',6,'Position',[220,panel2height-55,21,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        
        uicontrol('Parent',HeartAnalysisResults,'Style','text','FontWeight','bold','String',MeanPAT,'Units','Pixels','FontSize',6,'Position',[360,panel2height-15,21,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',HeartAnalysisResults,'Style','text','FontWeight','bold','String',MedianPAT,'Units','Pixels','FontSize',6,'Position',[360,panel2height-25,21,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',HeartAnalysisResults,'Style','text','FontWeight','bold','String',STDPAT,'Units','Pixels','FontSize',6,'Position',[360,panel2height-35,21,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',HeartAnalysisResults,'Style','text','FontWeight','bold','String',speedpat,'Units','Pixels','FontSize',6,'Position',[360,panel2height-43,21,8],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        
        hist(HRReportaxes1,rr);
        hist(HRReportaxes2,HR2);
        
        set(HRReportaxes1,'FontSize',graphfontsize);
        set(HRReportaxes2,'FontSize',graphfontsize);
        HRReportaxes1.XLabel.String = ('HR, (beats/min)');
        HRReportaxes2.XLabel.String = ('RR, (ms)');
        
        scatter(HRReportaxes3,rr(1:end-1),rr(2:end),'filled','d');
        set(HRReportaxes3,'FontSize',graphfontsize);
        HRReportaxes3.XLabel.String = ('RR_{n-1} (ms)');
        HRReportaxes3.YLabel.String = ('RR_{n} (ms)');
        
        % BC
        
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',BMI,'Units','Pixels','FontSize',6,'Position',[100,panel3height-15,22,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',BMR,'Units','Pixels','FontSize',6,'Position',[100,panel3height-25,30,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',FatMassPr,'Units','Pixels','FontSize',6,'Position',[100,panel3height-35,22,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',FatFMassPr,'Units','Pixels','FontSize',6,'Position',[100,panel3height-43,22,8],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',TBW,'Units','Pixels','FontSize',6,'Position',[240,panel3height-15,22,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',TBWPrFFM,'Units','Pixels','FontSize',6,'Position',[240,panel3height-25,22,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',TBWPrTW,'Units','Pixels','FontSize',6,'Position',[240,panel3height-35,22,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',ECWPrTBW,'Units','Pixels','FontSize',6,'Position',[240,panel3height-43,22,8],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',ICWPrTBW,'Units','Pixels','FontSize',6,'Position',[410,panel3height-15,22,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',MMass,'Units','Pixels','FontSize',6,'Position',[410,panel3height-25,22,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',MMassPrW,'Units','Pixels','FontSize',6,'Position',[410,panel3height-35,22,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',RDEE,'Units','Pixels','FontSize',6,'Position',[410,panel3height-45,30,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',Resistance,'Units','Pixels','FontSize',6,'Position',[400,panel3height-70,30,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',Reactance,'Units','Pixels','FontSize',6,'Position',[400,panel3height-80,30,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        uicontrol('Parent',BodyCompResults,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',Impedance,'Units','Pixels','FontSize',6,'Position',[400,panel3height-90,30,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        TimeNow = datestr(datetime('now','Format','yyyy-MM-dd hh:mm:ss'));
        uicontrol('Parent',PrintFile,'Style','text','HorizontalAlignment','left','FontWeight','normal','String',TimeNow,'Units','Pixels','FontSize',6,'Position',[360,30,300,10],'BackGroundColor',Backgroundcolor,'HorizontalAlignment','left');
        
        piepie = pie(BCReportaxes1,xpie,labelspie);
        piepie(2).FontSize = 7;
        piepie(4).FontSize = 7;
        piepie(6).FontSize = 7;
        piepie(8).FontSize = 7;
        
        hold(BCReportaxes2,'on');
        
        if Sexnr==1
            plot(BCReportaxes2,Male50X,Male50Y,Male75X,Male75Y,Male95X,Male95Y);
            text(380,60,'Dehidrated','Parent',BCReportaxes2,'FontSize',graphfontsize);
            text(200,26,'Hyper-hidrated','Parent',BCReportaxes2,'FontSize',graphfontsize);
            text(360,32,sprintf('Body cell\n Mass decrease'),'Parent',BCReportaxes2,'FontSize',graphfontsize);
            text(220,53,sprintf('Body cell\n Mass increase'),'Parent',BCReportaxes2,'FontSize',graphfontsize);
        else
            plot(BCReportaxes2,Female50X,Female50Y,Female75X,Female75Y,Female95X,Female95Y);
            text(440,65,'Dehidrated','Parent',BCReportaxes2,'FontSize',graphfontsize);
            text(250,25,'Hyper-hidrated','Parent',BCReportaxes2,'FontSize',graphfontsize);
            text(440,32,sprintf('Body cell\n Mass decrease'),'Parent',BCReportaxes2,'FontSize',graphfontsize);
            text(250,58,sprintf('Body cell\n Mass increase'),'Parent',BCReportaxes2,'FontSize',graphfontsize);
        end
        plot(BCReportaxes2,Resistance1,Reactance1,'or','LineWidth',3)
        box(BCReportaxes2,'off');
        hold(BCReportaxes2,'off');
        set(BCReportaxes2,'FontSize',graphfontsize);
        BCReportaxes2.XLabel.String = 'Reactance';
        BCReportaxes2.YLabel.String = 'Resistance';
        
        
        
        % Report saving Q
        set(PrintFile, 'PaperPosition', [0 0 5 7.7]); %Position plot at left hand corner with width 5 and height 5.
        set(PrintFile, 'PaperSize', [5 7.7]); %Set the paper to have width 5 and height 5
        
        PrintReportQ=figure('Color',[1 1 1],'MenuBar','none','Name','Print report','NumberTitle','off','Position',[400 100 300 80],'ReSize','off');
        set(PrintReportQ, 'Visible', 'on');
        uicontrol(PrintReportQ,'Style','text','HorizontalAlignment','left','FontSize',8,'FontWeight','normal','String','Save this report as PDF?','Units','Pixels','Position',[20, 60, 200, 13],'BackGroundColor',[1,1,1]);
        
        ButtonSaveReportY=uicontrol('Parent',PrintReportQ,'Style','pushbutton','String','Yes','Units','pixels','Position',[1 2 148 40],'BackGroundColor',[1 1 1]);
        set(ButtonSaveReportY,'Callback',@BPrintReportYCallback);
        ButtonSaveReportN=uicontrol('Parent',PrintReportQ,'Style','pushbutton','String','No','Units','pixels','Position',[150 2 148 40],'BackGroundColor',[1 1 1]);
        set(ButtonSaveReportN,'Callback',@BPrintReportNCallback);
        
        
        function BPrintReportYCallback(hObject,event)
            currentFolder = pwd;
            ReportPathName = strcat(currentFolder,'\',MeasureDate);
            try
                saveas(PrintFile,ReportPathName,'pdf'); %Save figure
            catch
                display('Name invalid or file is opened');
            end
            close(PrintFile);
            close(PrintReportQ);
            
        end
        
        function BPrintReportNCallback(hObject,event)
            close(PrintFile);
            close(PrintReportQ);
        end
    end

    function hSigCompareitemCallback(hObject, eventdata)
        set(SigCompare,'Visible', 'on');
        SliderCompS1=uicontrol('Parent',SigCompare,'Style','slider','Units','pixels','Max',100,'Min',0,'Value',0,'SliderStep',[0.05 0.1],'Position',[790 250 20 150],'BackGroundColor',[0.9 0.9 0.9]);
        
        SliderCompS2=uicontrol('Parent',SigCompare,'Style','slider','Units','pixels','Max',100,'Min',0,'Value',0,'SliderStep',[0.05 0.1],'Position',[20 20 700 20],'BackGroundColor',Backgroundcolor);
        
        SliderCompS3=uicontrol('Parent',SigCompare,'Style','slider','Units','pixels','Max',100,'Min',1,'Value',1,'SliderStep',[0.05 0.1],'Position',[750 340 20 230],'BackGroundColor',Backgroundcolor);
        
        SliderCompS4=uicontrol('Parent',SigCompare,'Style','slider','Units','pixels','Max',100,'Min',1,'Value',1,'SliderStep',[0.05 0.1],'Position',[750 90 20 230],'BackGroundColor',Backgroundcolor);
        
        % Buttons
        ButtonComp1=uicontrol('Parent',SigCompare,'Style','pushbutton','String','-','FontWeight','normal','FontSize',25,'Units','pixels','Position',[820 40 40 40],'BackGroundColor',buttoncolors);
        set(ButtonComp1,'Callback',@B1CompCallback);
        ButtonComp2=uicontrol('Parent',SigCompare,'Style','pushbutton','String','+','FontWeight','normal','FontSize',25,'Units','pixels','Position',[880 40 40 40],'BackGroundColor',buttoncolors);
        set(ButtonComp2,'Callback',@B2CompCallback);
        uicontrol('Parent',SigCompare,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Choose a Signal','Units','Pixels','Position',[820 220 150 20],'BackGroundColor',Backgroundcolor);
        uicontrol('Parent',SigCompare,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Choose a signal','Units','Pixels','Position',[820 450 150 20],'BackGroundColor',Backgroundcolor);
        uicontrol('Parent',SigCompare,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Use slider to compare','Units','Pixels','Position',[820 310 150 20],'BackGroundColor',Backgroundcolor);
        
        PoPUpCompare1=uicontrol('Parent',SigCompare,'Style','popupmenu','ToolTipString','Choose Graph','String',{'EKG Lead I','EKG Lead II','EKG Lead III','IPG FOOT','IPG PALM','IPG PALM AMPL'},'Units','Pixels','Position',[820 200 150 20],'BackGroundColor',Backgroundcolor);
        set(PoPUpCompare1,'Callback',@PCallbackCompare1);
        
        PoPUpCompare2=uicontrol('Parent',SigCompare,'Style','popupmenu','ToolTipString','Choose Graph','String',{'EKG Lead II','EKG Lead I','EKG Lead III','IPG FOOT','IPG PALM','IPG PALM AMPL'},'Units','Pixels','Position',[820 430 150 20],'BackGroundColor',Backgroundcolor);
        set(PoPUpCompare2,'Callback',@PCallbackCompare2);
        
        hListener = addlistener(SliderCompS1,'ContinuousValueChange',@SLCompCallback1);
        setappdata(SliderCompS1,'sliderListener',hListener);
        hListener = addlistener(SliderCompS2,'ContinuousValueChange',@SLCompCallback2);
        setappdata(SliderCompS2,'sliderListener',hListener);
        hListener = addlistener(SliderCompS3,'ContinuousValueChange',@SLCompCallback3);
        setappdata(SliderCompS3,'sliderListener',hListener);
        hListener = addlistener(SliderCompS4,'ContinuousValueChange',@SLCompCallback4);
        setappdata(SliderCompS4,'sliderListener',hListener);
        
        SignalComparePlot();
    end

    function hFileInfoCallback(hObject, eventdata)
        
        Analysis1=figure('Color',[1 1 1],'MenuBar','none','Name','Parameters','NumberTitle','off','Position',[500 500 800 450],'ReSize','off');
        
    end

    function hViewData(hObject, eventdata)
        set(SavedData,'Visible','on');
        filenamedataview = strcat(PatientName,'.txt');
        txtSavedData = strcat('Historical Analysis of: ',' ',PatientName);
        tcb1 = uicontrol('Parent',SavedData,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',txtSavedData,'Units','Pixels','Position',[50, 400, 300, 20],'BackGroundColor',Backgroundcolor,'FontSize',12);
        try
            SDIDr = fopen(filenamedataview,'r');
            A1 = textscan(SDIDr,'%s','Delimiter','\n');
        catch
            display('invalid patient name');
            set(SavedData,'Visible','off');
            return;
        end
        
        i = size(A1{1,1});
        u = i(1);
        for datanr = 1:u
            a = A1{1,1}{datanr,1};
            b = textscan(a,'%s','Delimiter','\t');
            %weight
            num1 = b{1,1}{2,1};
            num11 = str2double(num1);
            weightSavedDATA1(datanr) = num11;
            %BMI
            num2 = b{1,1}{3,1};
            num22 = str2double(num2);
            BMISavedDATA1(datanr) = num22;
            %Fat Mass
            num3 = b{1,1}{4,1};
            num33 = str2double(num3);
            FMSavedDATA1(datanr) = num33;
            %Resistance
            num4 = b{1,1}{5,1};
            num44 = str2double(num4);
            ResistanceSavedDATA1(datanr) = num44;
            %Reactance
            num5 = b{1,1}{6,1};
            num55 = str2double(num5);
            ReactanceSavedDATA1(datanr) = num55;
            %MedianPAT
            num6 = b{1,1}{7,1};
            num66 = str2double(num6);
            MedianPATSavedDATA1(datanr) = num66;
            %MeanPAT
            num7 = b{1,1}{8,1};
            num77 = str2double(num7);
            MeanPATSavedDATA1(datanr) = num77;
            %STDPAT
            num8 = b{1,1}{9,1};
            num88 = str2double(num8);
            STDPATSavedDATA1(datanr) = num88;
            %Date
            num9 = b{1,1}{10,1};
            %num88 = str2double(num8);
            DateSavedDATA1(datanr) = datenum(num9);
        end
        [dns,sidx] = sort(DateSavedDATA1);
        for datanr = 1:max(size(sidx))
            DateSavedDATA(datanr) = DateSavedDATA1(sidx(datanr));
            weightSavedDATA(datanr) = weightSavedDATA1(sidx(datanr));
            BMISavedDATA(datanr) = BMISavedDATA1(sidx(datanr));
            FMSavedDATA(datanr) = FMSavedDATA1(sidx(datanr));
            ResistanceSavedDATA(datanr) = ResistanceSavedDATA1(sidx(datanr));
            ReactanceSavedDATA(datanr) = ReactanceSavedDATA1(sidx(datanr));
            MedianPATSavedDATA(datanr) = MedianPATSavedDATA1(sidx(datanr));
            MeanPATSavedDATA(datanr) = MeanPATSavedDATA1(sidx(datanr));
            STDPATSavedDATA(datanr) = STDPATSavedDATA1(sidx(datanr));
        end
        plot(SavedDataaxis,DateSavedDATA,weightSavedDATA,'r','LineWidth',1.5);
        SavedDataaxis.Title.String = 'Weight Change';
        SavedDataaxis.YLabel.String = 'kg';
        SavedDataaxis.XLabel.String = 'Time';
        datetick('x','yyyy-mm-dd');
        grid(SavedDataaxis,'on');
        set(SavedDataaxis,'FontSize',8);
    end

    function hSaveData(hObject, eventdata)
        if FileOpened == 1
            
            PatientNameSaveDataEdit = uicontrol('Parent',SaveParametersData,'Style','edit','HorizontalAlignment','left','FontWeight','bold','String',PatientName,'Units','Pixels','Position',[70, 250, 150, 20],'BackGroundColor',Backgroundcolor);
            set(PatientNameSaveDataEdit,'Callback',@TBCallbackPatientNameSaveDataEdit);
            PatientDateSaveDataEdit = uicontrol('Parent',SaveParametersData,'Style','edit','HorizontalAlignment','left','FontWeight','bold','String',MeasureDate,'Units','Pixels','Position',[270, 250, 80, 20],'BackGroundColor',Backgroundcolor);
            set(PatientDateSaveDataEdit,'Callback',@TBCallbackPatientDateSaveDataEdit);
            
            infox = 50;
            infox2 = 150;
            infox3 = 250;
            
            
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Weight:','FontSize',10,'Units','Pixels','Position',[infox 220 100 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','BMI:','FontSize',10,'Units','Pixels','Position',[infox 200 100 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Fat Mass:','FontSize',10,'Units','Pixels','Position',[infox 180 100 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Resistance:','FontSize',10,'Units','Pixels','Position',[infox 160 100 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Reactance:','FontSize',10,'Units','Pixels','Position',[infox 140 100 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','MedianPAT:','FontSize',10,'Units','Pixels','Position',[infox 120 100 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','MeanPAT:','FontSize',10,'Units','Pixels','Position',[infox 100 100 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','STDPAT:','FontSize',10,'Units','Pixels','Position',[infox 80 100 20],'BackGroundColor',Backgroundcolor);
            
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',Weight,'FontSize',10,'Units','Pixels','Position',[infox2 220 50 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',BMI,'FontSize',10,'Units','Pixels','Position',[infox2 200 50 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',FM,'FontSize',10,'Units','Pixels','Position',[infox2 180 50 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',Resistance,'FontSize',10,'Units','Pixels','Position',[infox2 160 50 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',Reactance,'FontSize',10,'Units','Pixels','Position',[infox2 140 50 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',MedianPAT,'FontSize',10,'Units','Pixels','Position',[infox2 120 50 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',MeanPAT,'FontSize',10,'Units','Pixels','Position',[infox2 100 50 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',STDPAT,'FontSize',10,'Units','Pixels','Position',[infox2 80 50 20],'BackGroundColor',Backgroundcolor);
            
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','kg','FontSize',10,'Units','Pixels','Position',[infox3 220 100 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Index','FontSize',10,'Units','Pixels','Position',[infox3 200 100 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','%','FontSize',10,'Units','Pixels','Position',[infox3 180 100 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Ohm/m','FontSize',10,'Units','Pixels','Position',[infox3 160 100 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','Ohm/m','FontSize',10,'Units','Pixels','Position',[infox3 140 100 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ms','FontSize',10,'Units','Pixels','Position',[infox3 120 100 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ms','FontSize',10,'Units','Pixels','Position',[infox3 100 100 20],'BackGroundColor',Backgroundcolor);
            uicontrol('Parent',SaveParametersData,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','ms','FontSize',10,'Units','Pixels','Position',[infox3 80 100 20],'BackGroundColor',Backgroundcolor);
            
            
            set(SaveParametersData,'Visible','on');
            
        else
            return;
        end
        
    end

    function PlotGraphs()
        
        Signal_Start_Time = 1;
        Signal_Time_End = Signal_Time/Time_Diff;
        % Nukirpto signalo ilgis
        Signal_Start_End = Signal_Time_End - Signal_Start_Time;
        % Kiek signalo liko
        Signal_Time_Left = Signal_Time-Signal_Start_End;
        % Paspaudimo trukm
        Signal_Time_Tick = Signal_Time_Left/500;
        % Paskaiiuojame signal ribas
        Signal_Time_End_Real = round(Signal_Start_End+(Signal_Time_Tick*SliderVal));
        Signal_Start_Time_Real = round(Signal_Time_End_Real-(Signal_Time_End-1));
        if Signal_Start_Time_Real<1
            Signal_Start_Time_Real = 1;
        end
        if Signal_Time_End_Real>Signal_Time
            Signal_Time_End_Real = Signal_Time;
        end
        Plot_graph_Time = DATA_Time(Signal_Start_Time_Real:Signal_Time_End_Real);
        axesnr = 1;
        for i= 1:1:10
            if CBox(i) == 1
                if CBoxPP(i) == 1
                    if i == 2
                        %Graph_Signal = [rrRR, rIndexRR(1:length(rIndexRR)-1)]
                        Graph_Signal = rrRR;
                        
                    elseif i == 10
                        Graph_Signal = BACKUP_DATA(: ,2);
                    else
                        Graph_Signal = BACKUP_DATA(: ,i);
                    end
                else
                    if i == 2
                        Graph_Signal = rrRR;
                    elseif i == 10
                        Graph_Signal = BACKUP_DATA(: ,2);
                    else
                        Graph_Signal = DATA_PP_MAIN(: ,i);
                    end
                end
                set(ax(axesnr),'Visible','on');
                set(SignalText(axesnr),'Visible','on');
                set(SignalText(axesnr),'String',Labeltrue(i));
                set(SignalDim(axesnr),'Visible','on');
                set(SignalDim(axesnr),'String',header.PhysDim(i));
                
                Plot_Graph_Signal = Graph_Signal(Signal_Start_Time_Real:Signal_Time_End_Real);
                plot(ax(axesnr),Plot_graph_Time,Plot_Graph_Signal);
                if CBox(2) == 1
                    set(ax1Resp,'Visible','on');
                    saw = BACKUP_DATA(: ,2);
                    Plot_Graph_Signal_saw = saw(Signal_Start_Time_Real:Signal_Time_End_Real);
                    plot(ax1Resp,Plot_graph_Time,Plot_Graph_Signal_saw,'r');
                    ax1Resp.Color(4)=0.3;
                    ax1Resp.YLim = ([50 200]);
                    ax(1).Color(4)=0.3;
                    ax1Resp.YTick = '';
                    ax1Resp.YColor = [1 1 1];
                    ax1Resp.XTick = '';
                    ax1Resp.XColor = [1 1 1];
                    ax1Resp.XLim = ([DATA_Time(Signal_Start_Time_Real) DATA_Time(Signal_Time_End_Real)]);
                else
                    set(ax1Resp,'Visible','off');
                end
                
                grid(ax(axesnr),'minor');
                ax(axesnr).XLim = ([DATA_Time(Signal_Start_Time_Real) DATA_Time(Signal_Time_End_Real)]);
                if axesnr<11
                    ax(axesnr).XTick = '';
                    ax(axesnr).XColor = [1 1 1];
                else
                end
                axesnr = axesnr + 1;
            end
            
            
        end
        
        if axesnr < 10
            for like = axesnr:1:10
                cla(ax(like));
                set(ax(like),'Visible','off');
                set(SignalText(like),'Visible','off');
                set(SignalDim(like),'Visible','off');
            end
        end
        Graph_Signal = DATA(: ,8);
        Plot_Graph_Signal = Graph_Signal(Signal_Start_Time_Real:Signal_Time_End_Real);
        plot(axaxes,Plot_graph_Time,Plot_Graph_Signal,'k');
        axaxes.XLim = ([DATA_Time(Signal_Start_Time_Real) DATA_Time(Signal_Time_End_Real)]);
        axaxes.YLim = ([-100 DATA_Time(Signal_Time_End_Real)]);
        axaxes.YTick = '';
        axaxes.YColor = [1 1 1];
        set(ax, 'FontSize',7);
        box off;
    end

%% Buttons callbacks
    function B1Callback(hObject,event)
        if Time_Diff>1
            Time_Diff = Time_Diff/2;
        else
        end
        PlotGraphs();
        
    end

    function B2Callback(hObject,event)
        if Time_Diff<64
            Time_Diff = Time_Diff*2;
        else
        end
        PlotGraphs();
        
    end

    function B3Callback(hObject,event)
        
        if axes_aukstis<150
            axes_aukstis = axes_aukstis + 10;
            axes_height = axes_aukstis + 10;
            for i= 1:1:10
                set(ax(i),'Position',[axesatstumasx, panel_height - (i * axes_height), axes_ilgis, axes_aukstis]);
                set(SignalText(i),'Position',[axesatstumasxtext, panel_height - (i * axes_height)-axesatstumasytext, axes_ilgis, 20]);
                set(SignalDim(i),'Position',[axesatstumasxtext-5, panel_height - (i * axes_height)-axesatstumasytextdim, axes_ilgis, 20]);
                
            end
        end
    end

    function B4Callback(hObject,event)
        if axes_aukstis>100
            axes_aukstis = axes_aukstis - 10;
            axes_height = axes_aukstis + 10;
            for i= 1:1:10
                set(ax(i),'Position',[axesatstumasx, panel_height - (i * axes_height), axes_ilgis, axes_aukstis]);
                set(SignalText(i),'Position',[axesatstumasxtext, panel_height - (i * axes_height)-axesatstumasytext, axes_ilgis, 20]);
                set(SignalDim(i),'Position',[axesatstumasxtext-5, panel_height - (i * axes_height)-axesatstumasytextdim, axes_ilgis, 20]);
                
            end
        end
    end
% AF Analysis
    function B7Callback(hObject,event)
        
        if FileOpened == 1
        else
            return;
        end
        
        set(Analysis2,'Visible','on');
        figure(Analysis2);
        AFAnalysis();
        
    end
% AS Analysis
    function B5Callback(hObject,event)
        if FileOpened == 1
        else
            return;
        end
        set(Analysis1,'Visible','on');
        figure(Analysis1);
        try
            %ECGRRQualityCheck();
                    AnalysisECG();
                    PlotArterialStiffness()
        catch
            return;
        end
        
    end
% BCA
    function B6Callback(hObject,event)
        
        if FileOpened == 1
        else
            return;
        end
        
        set(BCA,'Visible','on');
        figure(BCA);
        BodyParameters();
        BIVAPlot();
        
        % BMI, Fat mass charts
        
        uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','bold','String','Underweight','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[300 470 150 20],'BackGroundColor',[0.9,0.9,1]);
        uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','bold','String','Normal','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[450 470 70 20],'BackGroundColor',[0.9,1,0.9]);
        uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','bold','String','Overweight','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[520 470 130 20],'BackGroundColor',[1,0.9,0.9]);
        uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','center','FontWeight','bold','String','Obesity','FontSize',Pattextfontsize+3,'Units','Pixels','Position',[650 470 250 20],'BackGroundColor',[1,0.8,0.8]);
        
        
        % Patient Info
        
        %texts
        PatInfo1 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',PatientName,'FontSize',Pattextfontsize+4,'Units','Pixels','Position',[Pattextx+Pattextxans Pattexty 150 20],'BackGroundColor',Backgroundcolor);
        PatInfo2 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',strcat(int2str(Weight),'kg'),'FontSize',Pattextfontsize+4,'Units','Pixels','Position',[Pattextx+Pattextxans Pattexty-30 150 20],'BackGroundColor',Backgroundcolor);
        PatInfo3 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',strcat(int2str(Height),'cm'),'FontSize',Pattextfontsize+4,'Units','Pixels','Position',[Pattextx+Pattextxans Pattexty-60 150 20],'BackGroundColor',Backgroundcolor);
        PatInfo4 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',Age,'FontSize',Pattextfontsize+4,'Units','Pixels','Position',[Pattextx+Pattextxans Pattexty-90 150 20],'BackGroundColor',Backgroundcolor);
        PatInfo5 = uicontrol('Parent',BCA,'Style','text','HorizontalAlignment','left','FontWeight','bold','String',Sex,'FontSize',Pattextfontsize+4,'Units','Pixels','Position',[Pattextx+Pattextxans Pattexty-120 150 20],'BackGroundColor',Backgroundcolor);
        
        %Edit buttons
        [iconedit,iconeditmap]=imread('tool_edgecolor.gif');
        iconedit = ind2rgb(iconedit,iconeditmap);
        Pat1Edit=uicontrol('Parent',BCA,'Style','pushbutton','cdata',iconedit,'FontWeight','normal','FontSize',25,'Units','pixels','Position',[Pattextx+Pattextxbuttons Pattexty+Paticonycorr 18 18],'BackGroundColor',buttoncolors);
        set(Pat1Edit,'Callback',@Pat1EditCallback);
        Pat2Edit=uicontrol('Parent',BCA,'Style','pushbutton','cdata',iconedit,'FontWeight','normal','FontSize',25,'Units','pixels','Position',[Pattextx+Pattextxbuttons Pattexty-30+Paticonycorr 18 18],'BackGroundColor',buttoncolors);
        set(Pat2Edit,'Callback',@Pat2EditCallback);
        Pat3Edit=uicontrol('Parent',BCA,'Style','pushbutton','cdata',iconedit,'FontWeight','normal','FontSize',25,'Units','pixels','Position',[Pattextx+Pattextxbuttons Pattexty-60+Paticonycorr 18 18],'BackGroundColor',buttoncolors);
        set(Pat3Edit,'Callback',@Pat3EditCallback);
        Pat4Edit=uicontrol('Parent',BCA,'Style','pushbutton','cdata',iconedit,'FontWeight','normal','FontSize',25,'Units','pixels','Position',[Pattextx+Pattextxbuttons Pattexty-90+Paticonycorr 18 18],'BackGroundColor',buttoncolors);
        set(Pat4Edit,'Callback',@Pat4EditCallback);
        Pat5Edit=uicontrol('Parent',BCA,'Style','pushbutton','cdata',iconedit,'FontWeight','normal','FontSize',25,'Units','pixels','Position',[Pattextx+Pattextxbuttons Pattexty-120+Paticonycorr 18 18],'BackGroundColor',buttoncolors);
        set(Pat5Edit,'Callback',@Pat5EditCallback);
        
        % Editboxes
        NameEditEdit = uicontrol('Parent',BCA,'Style','edit','HorizontalAlignment','left','FontWeight','normal','String',PatientName,'Units','Pixels','Position',[Pattextx+Pattextxans Pattexty 120 20],'BackGroundColor',Backgroundcolor);
        set(NameEditEdit,'Callback',@TBCallbackNameEdit);
        set(NameEditEdit,'Visible','off');
        
        WeightEditEdit = uicontrol('Parent',BCA,'Style','edit','HorizontalAlignment','left','FontWeight','normal','String',Weight,'Units','Pixels','Position',[Pattextx+Pattextxans Pattexty-30 120 20],'BackGroundColor',Backgroundcolor);
        set(WeightEditEdit,'Callback',@TBCallbackWeightEdit);
        set(WeightEditEdit,'Visible','off');
        
        HeightEditEdit = uicontrol('Parent',BCA,'Style','edit','HorizontalAlignment','left','FontWeight','normal','String',Height,'Units','Pixels','Position',[Pattextx+Pattextxans Pattexty-60 120 20],'BackGroundColor',Backgroundcolor);
        set(HeightEditEdit,'Callback',@TBCallbackHeightEdit);
        set(HeightEditEdit,'Visible','off');
        
        AgeEditEdit = uicontrol('Parent',BCA,'Style','edit','HorizontalAlignment','left','FontWeight','normal','String',Age,'Units','Pixels','Position',[Pattextx+Pattextxans Pattexty-90 120 20],'BackGroundColor',Backgroundcolor);
        set(AgeEditEdit,'Callback',@TBCallbackAgeEdit);
        set(AgeEditEdit,'Visible','off');
        
        PoPUpSexEdit=uicontrol('Parent',BCA,'Style','popupmenu','ToolTipString','Sex','String',{'','Male','Female'},'Units','Pixels','Position',[Pattextx+Pattextxans Pattexty-120 120 20],'BackGroundColor',Backgroundcolor);
        set(PoPUpSexEdit,'Callback',@PoPUpSexEditCallback);
        set(PoPUpSexEdit,'Visible','off');
        
        
        
        %Callbacks
        function Pat1EditCallback(hObject,event)
            set(NameEditEdit,'Visible','on');
        end
        function Pat2EditCallback(hObject,event)
            set(WeightEditEdit,'Visible','on');
        end
        function Pat3EditCallback(hObject,event)
            set(HeightEditEdit,'Visible','on');
        end
        function Pat4EditCallback(hObject,event)
            set(AgeEditEdit,'Visible','on');
        end
        function Pat5EditCallback(hObject,event)
            set(PoPUpSexEdit,'Visible','on');
        end
        
        %Editcallbacks
        function TBCallbackNameEdit(hObject, eventdata, handles)
            PatientName = get(hObject,'String');
            set(NameEditEdit,'Visible','off');
            set(PatInfo1,'String',PatientName);
            set(PatientNameRes,'String',PatientName);
            BodyParameters();
        end
        
        function TBCallbackWeightEdit(hObject, eventdata, handles)
            Weight = str2double(get(hObject,'String'));
            set(WeightEditEdit,'Visible','off');
            set(PatInfo2,'String',strcat(int2str(Weight),'kg'));
            BodyParameters();
        end
        
        function TBCallbackHeightEdit(hObject, eventdata, handles)
            Height = str2double(get(hObject,'String'));
            set(HeightEditEdit,'Visible','off');
            set(PatInfo3,'String',strcat(int2str(Height),'cm'));
            BodyParameters();
        end
        
        function TBCallbackAgeEdit(hObject, eventdata, handles)
            Age = str2double(get(hObject,'String'));
            set(AgeEditEdit,'Visible','off');
            set(PatInfo4,'String',int2str(Age));
            BodyParameters();
        end
        
        function PoPUpSexEditCallback(hObject,event)
            val = get(hObject,'Value');
            switch val
                case 1
                case 2
                    Sex = 'Male';
                    set(PatInfo5,'String','Male');
                    set(PoPUpSexEdit,'Visible','off');
                    Sexnr = 1;
                    BodyParameters();
                case 3
                    Sex = 'Female';
                    set(PatInfo5,'String','Female');
                    set(PoPUpSexEdit,'Visible','off');
                    Sexnr = 0;
                    BodyParameters();
            end
        end
        
        
        ParamText0 = uicontrol('Parent',AdvancedParametersPanel,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Advanced Parameters','FontSize',11,'Units','Pixels','Position',[50 300 250 20],'BackGroundColor',Backgroundcolor);
        d2 = Z * 10;
        d1 = round(d2);
        d1 = d1 / 10;
        cnames1 = {'seg 1','seg 2','seg 3','seg 4','seg 5','seg 6','seg 7','seg 8','seg 9','seg 10','seg 11','seg 12'};
        rnames1 = {'8 kHz','16 kHz','32 kHz','64 kHz','128 kHz'};
        Table1 = uitable(AdvancedParametersPanel,'Data',d1,'ColumnName',cnames1,'RowName',rnames1);
        Table1.Position(3) = Table1.Extent(3);
        Table1.Position(4) = Table1.Extent(4);
        Table1.Position(1) = 10;
        Table1.Position(2) = 160;
        
        ParamText1 = uicontrol('Parent',AdvancedParametersPanel,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Impedance |Z|, Ohm','FontSize',10,'Units','Pixels','Position',[50 275 150 20],'BackGroundColor',Backgroundcolor);
        
        d2 = Fi;
        cnames2 = {'seg 1','seg 2','seg 3','seg 4','seg 5','seg 6','seg 7','seg 8','seg 9','seg 10','seg 11','seg 12'};
        rnames2 = {'8 kHz','16 kHz','32 kHz','64 kHz','128 kHz'};
        Table2 = uitable(AdvancedParametersPanel,'Data',d2,'ColumnName',cnames2,'RowName',rnames2);
        Table2.Position(3) = Table2.Extent(3);
        Table2.Position(4) = Table2.Extent(4);
        Table2.Position(1) = 10;
        Table2.Position(2) = 10;
        
        ParamText2 = uicontrol('Parent',AdvancedParametersPanel,'Style','text','HorizontalAlignment','left','FontWeight','bold','String','Phase','FontSize',10,'Units','Pixels','Position',[50 125 150 20],'BackGroundColor',Backgroundcolor);
    end
% HRV
    function B8Callback(hObject,event)
        
        if FileOpened == 1
            set(HRVFigure,'Visible','on');
            figure(HRVFigure);
            rr = (RRI*2);
            HR = RRI/500;
            HR2 = 60./HR;
            hist(axhrv1,rr);
            hist(axhrv2,HR2);
            
            set(axhrv1,'FontSize',graphfontsize+1);
            set(axhrv2,'FontSize',graphfontsize+1);
            axhrv1.XLabel.String = ('RR, (ms)');
            axhrv2.XLabel.String = ('HR, (beats/min)');
            nn50 = 0;
            MeanRR = mean(rr);
            sMeanRR = sprintf('%0.2f',MeanRR);
            STDHR = std(HR2);
            sSTDHR = sprintf('%0.2f',STDHR);
            MeanHR = mean(HR2);
            sMeanHR = sprintf('%0.2f',MeanHR);
            STDRR = std(rr);
            sSTDRR = sprintf('%0.2f',STDRR);
            
            for a = 1:(length(rr)-1)
                rmssd(a) = ((rr(a+1) - rr(a)))^2;
                if a == 1;
                    NNLength1 = rr(a+1) - rr(a);
                    NNLength2 = rr(a+1) - rr(a);
                else
                    NNLength2 = rr(a+1) - rr(a);
                end
                dtNN(a) = abs(NNLength2 - NNLength1);
                if dtNN(a)>50
                    nn50 = nn50 + 1;
                end
                NNLength1 = NNLength2;
            end
            
            RMSSD = sqrtm(sum(rmssd)/(length(rr)-1));
            sRMSSD = sprintf('%1.3f',RMSSD);
            NN50 = nn50;
            sNN50 = sprintf('%1.3f',NN50);
            pNN50 = ((length(rr)-1)/100)*NN50;
            spNN50 = sprintf('%1.3f',pNN50);
            
            HRVParam = {'Mean RR' sMeanRR  'ms';...
                'STD RR' sSTDRR  'ms';...
                'Mean HR' sMeanHR  '1/min';
                'STD HR' sSTDHR  '1/min';
                'RMSSD' sRMSSD  'ms';
                'NN50' sNN50  '';
                'pNN50' spNN50  '%';};
            
            set(Table1,'Data',HRVParam);
            
            %plot(axhrv3,RRAnalysisSignal)
            
            
            Fs1 = 500;            % Sampling frequency
            T = 1/Fs1;             % Sampling period
            L = length(RRAnalysisSignal);             % Length of signal
            t1 = (0:L-1)*T;        % Time vector
            Y = fft(RRAnalysisSignal);
            
            P2 = abs(Y/L);
            P11 = P2((1:(L/2))+1);
            P11(2:end-1) = 2*P11(2:end-1);
            
            f = Fs1*(0:(L/2))/L;
            hold(axhrv3,'on')
            %         plot(axhrv3,f,P11);
            area(axhrv3,f(1:4),P11(1:4),'FaceColor',[1 0.8 0.8]);
            area(axhrv3,f(4:15),P11(4:15),'FaceColor',[0.8 0.8 1]);
            area(axhrv3,f(15:40),P11(15:40),'FaceColor',[0.8 1 0.8]);
            axhrv3.XLim = ([0 0.4]);
            axhrv3.YLim = ([0 25]);
            set(axhrv3,'FontSize',graphfontsize+1);
            axhrv3.XLabel.String = ('Frequency (Hz)');
            hold(axhrv3,'off')
            
            scatter(axhrv4,rr(1:end-1),rr(2:end),'filled','d');
            set(axhrv4,'FontSize',graphfontsize+2);
            axhrv4.XLabel.String = ('RR_{n-1} (ms)');
            axhrv4.YLabel.String = ('RR_{n} (ms)');
            
        else
            return;
        end
    end

    function B1CompCallback(hObject,event)
        if XSliderTick>1
            XSliderTick = XSliderTick/2;
        else
        end
        SignalComparePlot();
        axcomp1.Color(4)=0.3;
        axcomp2.Color(4)=0.3;
    end

    function B2CompCallback(hObject,event)
        if XSliderTick<32
            XSliderTick = XSliderTick*2;
        else
        end
        SignalComparePlot();
        axcomp1.Color(4)=0.3;
        axcomp2.Color(4)=0.3;
    end

    function BAPCallback(hObject,event)
        
        switch APStatus
            case 0
                set(AdvancedParametersPanel,'Visible','on');
                set(ButtonAP,'String','vvv Advanced Parameters');
                APStatus = 1;
            case 1
                set(AdvancedParametersPanel,'Visible','off');
                set(ButtonAP,'String','^^^ Advanced Parameters');
                APStatus = 0;
        end
        
    end

    function PatientNamechangeCallback(hObject,event)
        
        set(PatientNameResEdit,'Visible','on');
        
    end

    function ButtonSaveDataParametersCallback(hObject,event)
        
        if checkBCA == 1 && checkECG == 1
            
            filenamedata = strcat(PatientName,'.txt');
            
            SDID = fopen(filenamedata,'a');
            fprintf(SDID,'%s\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%f\t%s\r\n',PatientName,Weight,BMI,FM,Resistance,Reactance,MedianPAT,MeanPAT,STDPAT,MeasureDate);
            fclose(SDID);
            
        else
            msgbox('Please do Body composition and Arterial stiffness Analysis')
            
        end
    end

%% Sliders callbacks
    function SLCallback1(hObject,event)
        
        SliderVal = get(hObject,'Value');
        PlotGraphs();
    end

    function SLCallback2(hObject,event)
        
        SliderVal2 = get(hObject,'Value');
        diff = axes_aukstis*10-440;
        diffTick = diff/500;
        SliderValueTrue = abs(SliderVal2-500);%500
        diffEff = diffTick*SliderValueTrue;
        xposition = xpositiontrue+diffEff;
        set(AxispanelSlider,'Position',[0, xposition, ProgramWidth-200-20, 1800]);
        PlotGraphs();
        
    end

    function SLCallbackAF(hObject,event)
        
        SliderValAF = get(hObject,'Value');
        PlotAFAnalysis();
        
    end

    function SLCompCallback1(hObject,event)
        
        SliderValComp = get(hObject,'Value');
        dxComp = (300 - 30)/2;
        
        dxCompTick = (dxComp/100)*SliderValComp;
        
        set(axcomp1,'Position', [30, Comp1Y+dxCompTick+1, 700, 250]);
        set(axcomp2,'Position', [30, Comp2Y-dxCompTick, 700, 250]);
        axcomp1.Color(4)=0.3;
        axcomp2.Color(4)=0.3;
        
    end

    function SLCompCallback2(hObject,event)
        
        SliderValComp2 = get(hObject,'Value');
        SignalComparePlot();
        axcomp1.Color(4)=0.3;
        axcomp2.Color(4)=0.3;
    end

    function SLCompCallback3(hObject,event)
        
        SliderValComp3 = get(hObject,'Value');
        SignalComparePlot();
        axcomp1.Color(4)=0.3;
        axcomp2.Color(4)=0.3;
    end

    function SLCompCallback4(hObject,event)
        
        SliderValComp4 = get(hObject,'Value');
        SignalComparePlot();
        axcomp1.Color(4)=0.3;
        axcomp2.Color(4)=0.3;
    end

%% Checkboxes callbacks
    function CHCallback1(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBox(1) = 1;
            %set(CheckBoxPPW1,'Enable','on');
        elseif button_state == get(hObject,'Min')
            CBox(1) = 0;
            %set(CheckBoxPPW1,'Enable','off');
        end
        PlotGraphs();
    end

    function CHCallback2(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBox(2) = 1;
            %set(CheckBoxPPW2,'Enable','on');
        elseif button_state == get(hObject,'Min')
            CBox(2) = 0;
            %set(CheckBoxPPW2,'Enable','off');
        end
        PlotGraphs();
    end

    function CHCallback3(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBox(3) = 1;
            set(CheckBoxPPW1,'Enable','on');
        elseif button_state == get(hObject,'Min')
            CBox(3) = 0;
            set(CheckBoxPPW1,'Enable','off');
        end
        PlotGraphs();
    end

    function CHCallback4(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBox(4) = 1;
            set(CheckBoxPPW2,'Enable','on');
        elseif button_state == get(hObject,'Min')
            CBox(4) = 0;
            set(CheckBoxPPW2,'Enable','off');
        end
        PlotGraphs();
    end

    function CHCallback5(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBox(5) = 1;
            set(CheckBoxPPW3,'Enable','on');
        elseif button_state == get(hObject,'Min')
            CBox(5) = 0;
            set(CheckBoxPPW3,'Enable','off');
        end
        PlotGraphs();
    end

    function CHCallback6(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBox(6) = 1;
            set(CheckBoxPPW4,'Enable','on');
        elseif button_state == get(hObject,'Min')
            CBox(6) = 0;
            set(CheckBoxPPW4,'Enable','off');
        end
        PlotGraphs();
    end

    function CHCallback7(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBox(7) = 1;
            set(CheckBoxPPW5,'Enable','on');
        elseif button_state == get(hObject,'Min')
            CBox(7) = 0;
            set(CheckBoxPPW5,'Enable','off');
        end
        PlotGraphs();
    end

    function CHCallback8(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBox(8) = 1;
            set(CheckBoxPPW6,'Enable','on');
        elseif button_state == get(hObject,'Min')
            CBox(8) = 0;
            set(CheckBoxPPW6,'Enable','off');
        end
        PlotGraphs();
    end

    function CHCallback9(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBox(9) = 1;
        elseif button_state == get(hObject,'Min')
            CBox(9) = 0;
        end
        PlotGraphs();
    end

    function CHCallback10(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBox(10) = 1;
        elseif button_state == get(hObject,'Min')
            CBox(10) = 0;
        end
        PlotGraphs();
    end

%% PP Checkboxes callbacks
    function CHPPCallback1(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBoxPP(3) = 1;
        elseif button_state == get(hObject,'Min')
            CBoxPP(3) = 0;
        end
        PlotGraphs();
    end

    function CHPPCallback2(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBoxPP(4) = 1;
        elseif button_state == get(hObject,'Min')
            CBoxPP(4) = 0;
        end
        PlotGraphs();
    end

    function CHPPCallback3(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBoxPP(5) = 1;
        elseif button_state == get(hObject,'Min')
            CBoxPP(5) = 0;
        end
        PlotGraphs();
    end

    function CHPPCallback4(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBoxPP(6) = 1;
        elseif button_state == get(hObject,'Min')
            CBoxPP(6) = 0;
        end
        PlotGraphs();
    end

    function CHPPCallback5(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBoxPP(7) = 1;
        elseif button_state == get(hObject,'Min')
            CBoxPP(7) = 0;
        end
        PlotGraphs();
    end

    function CHPPCallback6(hObject,event)
        button_state = get(hObject,'Value');
        if button_state == get(hObject,'Max')
            CBoxPP(8) = 1;
        elseif button_state == get(hObject,'Min')
            CBoxPP(8) = 0;
        end
        PlotGraphs();
    end

%% PopUp Callbacks
    function PCallback1(hObject,event)
        PoPUpW11 = findobj(PoPUpW1);
        set(PoPUpW11,'Enable','off');
        val = get(hObject,'Value');
        %         try
        switch val
            case 1
                if abs(skew1)>0.7
                    ECG_SIGNAL_USED = EKG_CH1;
                    AnalysisECG();
                    PlotArterialStiffness()
                else
                    disp('error, signal not good enough');
                end
            case 2
                if abs(skew2)>0.7
                    ECG_SIGNAL_USED = EKG_CH2;
                    AnalysisECG();
                    PlotArterialStiffness()
                else
                    disp('error, signal not good enough');
                end
            case 3
                if abs(skew3)>0.7
                    ECG_SIGNAL_USED = EKG_CH3;
                    AnalysisECG();
                    PlotArterialStiffness()
                else
                    disp('error, signal not good enough');
                end
        end
        %         catch
        %             disp('AnalysisECG error');
        %         end
        set(PoPUpW11,'Enable','on');
    end

    function PCallbackCompare1(hObject,event)
        val = get(hObject,'Value');
        switch val
            case 1
                CompareSignal1 = 3;
                SignalComparePlot();
            case 2
                CompareSignal1 = 4;
                SignalComparePlot();
            case 3
                CompareSignal1 = 5;
                SignalComparePlot();
            case 4
                CompareSignal1 = 6;
                SignalComparePlot();
            case 5
                CompareSignal1 = 7;
                SignalComparePlot();
            case 6
                CompareSignal1 = 8;
                SignalComparePlot();
        end
        axcomp1.Color(4)=0.3;
        axcomp2.Color(4)=0.3;
    end

    function PCallbackCompare2(hObject,event)
        val = get(hObject,'Value');
        switch val
            case 1
                CompareSignal2 = 4;
                SignalComparePlot();
            case 2
                CompareSignal2 = 3;
                SignalComparePlot();
            case 3
                CompareSignal2 = 5;
                SignalComparePlot();
            case 4
                CompareSignal2 = 6;
                SignalComparePlot();
            case 5
                CompareSignal2 = 7;
                SignalComparePlot();
            case 6
                CompareSignal2 = 8;
                SignalComparePlot();
        end
        axcomp1.Color(4)=0.3;
        axcomp2.Color(4)=0.3;
    end

    function PoPUpBIVACallback(hObject,event)
        val = get(hObject,'Value');
        switch val
            case 1
                BivaState = 2;
                BIVAPlot();
            case 2
                BivaState = 10;
                BIVAPlot();
        end
    end

    function PoPUpSavedDataCallback(hObject,event)
        val = get(hObject,'Value');
        switch val
            case 1
                plot(SavedDataaxis,DateSavedDATA,weightSavedDATA,'r','LineWidth',1.5);
                SavedDataaxis.Title.String = 'Weight Change';
                SavedDataaxis.YLabel.String = 'kg';
                SavedDataaxis.XLabel.String = 'Time';
            case 2
                plot(SavedDataaxis,DateSavedDATA,BMISavedDATA,'r','LineWidth',1.5);
                SavedDataaxis.Title.String = 'Body Mass Index Change';
                SavedDataaxis.YLabel.String = 'Index';
                SavedDataaxis.XLabel.String = 'Time';
            case 3
                plot(SavedDataaxis,DateSavedDATA,FMSavedDATA,'r','LineWidth',1.5);
                SavedDataaxis.Title.String = 'Fat Mass Change';
                SavedDataaxis.YLabel.String = '%';
                SavedDataaxis.XLabel.String = 'Time';
            case 4
                plot(SavedDataaxis,DateSavedDATA,ResistanceSavedDATA,'r','LineWidth',1.5);
                SavedDataaxis.Title.String = 'Resistance Change';
                SavedDataaxis.YLabel.String = 'Ohm';
                SavedDataaxis.XLabel.String = 'Time';
            case 5
                plot(SavedDataaxis,DateSavedDATA,ReactanceSavedDATA,'r','LineWidth',1.5);
                SavedDataaxis.Title.String = 'Reactance Change';
                SavedDataaxis.YLabel.String = 'Ohm';
                SavedDataaxis.XLabel.String = 'Time';
            case 6
                plot(SavedDataaxis,DateSavedDATA,MedianPATSavedDATA,'r','LineWidth',1.5);
                SavedDataaxis.Title.String = 'Median Pulse Arival Time (PAT) Change';
                SavedDataaxis.YLabel.String = 'ms';
                SavedDataaxis.XLabel.String = 'Time';
            case 7
                plot(SavedDataaxis,DateSavedDATA,MeanPATSavedDATA,'r','LineWidth',1.5);
                SavedDataaxis.Title.String = 'Mean Pulse Arival Time (PAT) Change';
                SavedDataaxis.YLabel.String = 'ms';
                SavedDataaxis.XLabel.String = 'Time';
            case 8
                plot(SavedDataaxis,DateSavedDATA,STDPATSavedDATA,'r','LineWidth',1.5);
                SavedDataaxis.Title.String = 'Pulse Arival Time Standard Deviation Change';
                SavedDataaxis.YLabel.String = 'ms';
                SavedDataaxis.XLabel.String = 'Time';
        end
        datetick('x','yyyy-mm-dd');
        grid(SavedDataaxis,'on');
        set(SavedDataaxis,'FontSize',8);
    end
%% Analysis
    function ReadTXT()
        
        b = regexp(filenamec,'gdf','split');
        length1 = length(b{1,1});
        length2 = length(filenamec);
        if length1 == length2
            b = regexp(filenamec,'GDF','split');
        end
        
        filenamec = [b{1,1},'txt'];
        
        clear fid;
        fid = fopen([pathname,filenamec],'r');
        fidnr = 1;
        b = regexp(fgetl(fid),':','split');
        c = regexp(b{1,2},'kg','split');
        c = textscan(c{1,1},'%f');
        Weight = c{1,1};
        formatSpec = '%f ';
        dataArray = textscan(fid, '%s', 'Delimiter', '\t');
        DATATXT = dataArray{1,1}(:,1);
        % DATATXT = dataArray(1, 1);
        DATATXTtrue = DATATXT(2:end);
        values = str2double(DATATXT);
        
        ii = 41;
        DATAnames = DATATXTtrue(1:ii);
        DATA1 = values(ii+1:ii*2);
        DATA2 = values(ii*2+1:ii*3);
        DATA3 = values(ii*3+1:ii*4);
        DATA4 = values(ii*4+1:ii*5);
        DATA5 = values(ii*5+1:ii*6);
        
        IQ = [dataArray{1:end-1}];
        fclose(fid);
        
        Frequ8 = [DATA1(2,:).' ; DATA2(2,:).'; DATA3(2,:).'; DATA4(2,:).'; DATA5(2,:).'];
        ZeroI = [DATA1(7,:), DATA2(7,:), DATA3(7,:), DATA4(7,:), DATA5(7,:)];
        ZeroQ = [DATA1(8,:), DATA2(8,:), DATA3(8,:), DATA4(8,:), DATA5(8,:)];
        RchI = [DATA1(9:12,:).'; DATA2(9:12,:).'; DATA3(9:12,:).'; DATA4(9:12,:).'; DATA5(9:12,:).'];
        RchQ = [DATA1(13:16,:).'; DATA2(13:16,:).'; DATA3(13:16,:).'; DATA4(13:16,:).'; DATA5(13:16,:).'];
        Real_Q = [DATA1(30:41,:).'; DATA2(30:41,:).'; DATA3(30:41,:).'; DATA4(30:41,:).'; DATA5(30:41,:).'];
        Real_I = [DATA1(18:29,:).'; DATA2(18:29,:).'; DATA3(18:29,:).'; DATA4(18:29,:).'; DATA5(18:29,:).'];
        
        Measured_R = [99.13 196.32 694.11 945.43];
        
        
        for daznis = 1:length(RchI(:,1))
            Ki(1) = (Measured_R(2) - Measured_R(1))/(sqrt(RchI(daznis,2)*RchI(daznis,2) + RchQ(daznis,2)*RchQ(daznis,2))-sqrt(RchI(daznis,1)*RchI(daznis,1) + RchQ(daznis,1)*RchQ(daznis,1)));
            Ci(1) =  Measured_R(1) - Ki(1)* sqrt(RchI(daznis,1)*RchI(daznis,1) + RchQ(daznis,1)*RchQ(daznis,1));
            Ki(2) = (Measured_R(3) - Measured_R(2))/(sqrt(RchI(daznis,3)*RchI(daznis,3) + RchQ(daznis,3)*RchQ(daznis,3))-sqrt(RchI(daznis,2)*RchI(daznis,2) + RchQ(daznis,2)*RchQ(daznis,2)));
            Ci(2) =  Measured_R(2) - Ki(2)* sqrt(RchI(daznis,2)*RchI(daznis,2) + RchQ(daznis,2)*RchQ(daznis,2));
            Ki(3) = (Measured_R(4) - Measured_R(3))/(sqrt(RchI(daznis,4)*RchI(daznis,4) + RchQ(daznis,4)*RchQ(daznis,4))-sqrt(RchI(daznis,3)*RchI(daznis,3) + RchQ(daznis,3)*RchQ(daznis,3)));
            Ci(3) =  Measured_R(3) - Ki(3)* sqrt(RchI(daznis,3)*RchI(daznis,3) + RchQ(daznis,3)*RchQ(daznis,3));
            K = mean(Ki);
            C = mean(Ci(1:2));
            
            % modulis
            %test Z = K*sqrt(RchI(daznis,:).*RchI(daznis,:) + RchQ(daznis,:).*RchQ(daznis,:)) + C;
            System_phase = rad2deg(atan2(RchQ(daznis,:),(RchI(daznis,:))));
            
            Z(daznis,:) = K*sqrt(Real_I(daznis,:).*Real_I(daznis,:) + Real_Q(daznis,:).*Real_Q(daznis,:)) + C;
            %   Fi(daznis,:) = rad2deg(atan2(Real_Q(daznis,:),(Real_I(daznis,:))))-mean(System_phase(1));
            Fi(daznis,:) = rad2deg(atan2(Real_Q(daznis,:),(Real_I(daznis,:))))-mean(System_phase);
        end
        
    end

    function Calculate1()
        [data2,header] = sload([pathname filename],0,'OVERFLOWDETECTION','Off');
        
        % Diskretizavimo dazniai
        Fs = zeros(1,length(header.Label)-2);
        for i=2:length(header.Label) %skip sync, etapas signals
            Fs(i-1) = fix(header.AS.SPR(i)/header.Dur);
            b = sload([pathname filename],i,'OVERFLOWDETECTION','Off','SampleRate',Fs(i-1));
            switch i
                
                case 2
                    ETAPAS = b;
                case 3
                    EKG_CH1 = b;
                case 4
                    EKG_CH2 = b;
                case 5
                    EKG_CH3 = b;
                case 6
                    ADS_IPG = b;
                case 7
                    AFE_I = b;
                case 8
                    AFE_Q = b;
            end
            %eval(sprintf('%s1 = b;',header.Label{i})) %create labeled variables
        end
        clear b;
        
        time_ekg = 0:1/Fs(2):(length(EKG_CH1)-1)*1/Fs(2);
        time_ipg = 0:1/Fs(5):(length(AFE_I)-1)*1/Fs(5);
        time_RH  = 0:1/Fs(8):(length(RH)-1)*1/Fs(8);
        
        
        a = find (ETAPAS >= max(ETAPAS));
        PRADZIA = a(1)+10;
        
        ekg1=-EKG_CH1;
        ekg2=-EKG_CH2;
        ekg3=-EKG_CH3;
        ipg1 = ADS_IPG;
        ipg2 = AFE_Q;
        ipg3 = AFE_I;
        
        % filtering
        
        fc = 1; % cut off frequency in Hz
        % filter order 2
        [b,a] = butter(4,fc*2/Fs(2),'high');
        ekg1=filtfilt(b,a,ekg1);
        ekg2=filtfilt(b,a,ekg2);
        ekg3=filtfilt(b,a,ekg3);
        
        fc = 0.5; % cut off frequency in Hz
        % filter order 2
        [b,a] = butter(4,fc*2/Fs(2),'high');
        ipg1 = filtfilt(b,a,ipg1);
        ipg2 = filtfilt(b,a,ipg2);
        
        fc = 30;
        [b,a] = butter(6,fc*2/Fs(2),'low');
        ekg1=filtfilt(b,a,ekg1);
        ekg2=filtfilt(b,a,ekg2);
        ekg3=filtfilt(b,a,ekg3);
        
        fc = 15;
        [b,a] = butter(6,fc*2/Fs(2),'low');
        ipg1 = filtfilt(b,a,ipg1);
        ipg2 = filtfilt(b,a,ipg2);
        
    end

    function BodyParameters()
        
        if Weight == 0 || isnan(Weight)
            set(PatInfo22,'ForegroundColor','red');
            return;
        end
        set(PatInfo22,'ForegroundColor','black');
        if Height == 0 || isnan(Height)
            set(PatInfo33,'ForegroundColor','red');
            return;
        end
        set(PatInfo33,'ForegroundColor','black');
        if isempty(Age) || isnan(Age)
            set(PatInfo44,'ForegroundColor','red');
            return;
        end
        set(PatInfo44,'ForegroundColor','black');
        if Sex == '-'
            set(PatInfo55,'ForegroundColor','red');
            return;
        end
        
        set(PatInfo22,'ForegroundColor','black');
        set(PatInfo33,'ForegroundColor','black');
        set(PatInfo44,'ForegroundColor','black');
        set(PatInfo55,'ForegroundColor','black');
%         v = (Fi(4,2)-0.8685)
%         a = deg2rad(Fi(4,2)-0.8685)
        Resistance = Z(4,2) * cos(deg2rad(Fi(4,2)-0.8685));
        Reactance  = Z(4,2) * sin(deg2rad(Fi(4,2)-0.8685));
        Impedance = Z(4,2);
        
        
        BMI    = Weight*10000/(Height*Height);
        % HarrisBenedict equation
        if (Sex == 1)
            BMR = 88.362 + 13.397*Weight + 4.799*Height - 5.677*Age;
        else
            BMR = 447.593 + 9.247*Weight + 3.098*Height - 4.330*Age;
        end
        
        if strcmp(Sex,'Male') == 1;
            Sexint = 1;
        else
            Sexint = 0;
        end
        
        % Kyle et al.
        FFM = -4.104 + (0.518 * (Height*Height)/Resistance) + (0.231 * Weight)+...
            +(0.130 * Reactance) + (4.229 * Sexint);
        set(PatResult11,'String',sprintf('%0.2f',BMI));
        set(PatResult22,'String',strcat(sprintf('%0.2f',BMR),'kcal'));
        set(PatResult33,'String',strcat(sprintf('%0.2f',(Weight-FFM)*100/Weight),'%'));
        FatMassPr = (Weight-FFM)*100/Weight;
        set(PatResult44,'String',strcat(sprintf('%0.2f',FFM*100/Weight),'%'));
        FatFMassPr = FFM*100/Weight;
        if BMI<20 || BMI>25
            set(PatResult11,'BackgroundColor',[1,0.9,0.9]);
        else
            set(PatResult11,'BackgroundColor',[0.9,1,0.9]);
        end
        
        if BMR<1395 || BMR>1782
            set(PatResult22,'BackgroundColor',[1,0.9,0.9]);
        else
            set(PatResult22,'BackgroundColor',[0.9,1,0.9]);
        end
        FM = Weight-FFM;
        if ((Weight-FFM)*100/Weight)<FM1 || ((Weight-FFM)*100/Weight)>FM2
            set(PatResult33,'BackgroundColor',[1,0.9,0.9]);
        else
            set(PatResult33,'BackgroundColor',[0.9,1,0.9]);
        end
        
        if (FFM*100/Weight)<FFM1 || (FFM*100/Weight)>FFM2
            set(PatResult44,'BackgroundColor',[1,0.9,0.9]);
        else
            set(PatResult44,'BackgroundColor',[0.9,1,0.9]);
        end
        
        TBW = 6.53 + 0.36740 * (Height*Height)/Impedance + 0.17531*Weight - 0.11*Age+2.83*Sexint;
        
        ECW = -5.22 + 0.2 * (Height*Height)/Resistance + 0.005 * (Height*Height)/Reactance+...
            + 0.08*Weight + 1.9*1 + 1.86*Sexint;
        
        set(PatResult211,'String',strcat(sprintf('%0.2f',TBW),'kg'));
        set(PatResult222,'String',strcat(sprintf('%0.2f',TBW*100/FFM),'%'));
        TBWPrFFM = TBW*100/FFM;
        set(PatResult233,'String',strcat(sprintf('%0.2f',TBW*100/Weight),'%'));
        TBWPrTW = TBW*100/Weight;
        set(PatResult244,'String',strcat(sprintf('%0.2f',ECW/(TBW/100)),'%'));
        ECWPrTBW = ECW/(TBW/100);
        set(PatResult255,'String',strcat(sprintf('%0.2f',100-(ECW/(TBW/100))),'%'));
        ICWPrTBW = 100-(ECW/(TBW/100));
        
        if TBW<37.9 || TBW>52.9
            set(PatResult211,'BackgroundColor',[1,0.9,0.9]);
        else
            set(PatResult211,'BackgroundColor',[0.9,1,0.9]);
        end
        
        if (TBW*100/FFM)<73.6 || (TBW*100/FFM)>75.2
            set(PatResult222,'BackgroundColor',[1,0.9,0.9]);
        else
            set(PatResult222,'BackgroundColor',[0.9,1,0.9]);
        end
        
        if (TBW*100/Weight)<51.4 || (TBW*100/Weight)>61
            set(PatResult233,'BackgroundColor',[1,0.9,0.9]);
        else
            set(PatResult233,'BackgroundColor',[0.9,1,0.9]);
        end
        
        if (ECW/(TBW/100))<57.6 || (ECW/(TBW/100))>60.4
            set(PatResult244,'BackgroundColor',[1,0.9,0.9]);
        else
            set(PatResult244,'BackgroundColor',[0.9,1,0.9]);
        end
        ICW = TBW-ECW;
        if (100-(ECW/(TBW/100)))<39.6 || (100-(ECW/(TBW/100)))>42.4
            set(PatResult255,'BackgroundColor',[1,0.9,0.9]);
        else
            set(PatResult255,'BackgroundColor',[0.9,1,0.9]);
        end
        
        % ASMM -  appendicular skeletal muscle mass
        %  it refects the body muscle protein mass
        ASMM = -4.211 + (0.267*(Height*Height)/Resistance) + (0.095*Weight)+...
            +(1.909*Sexint) + (-0.012*Age) + (0.058*Reactance);
        
        % The Katch-McArdle Formula (Resting Daily Energy Expenditure):
        RDEE = 370 + 21.6*ASMM;
        
        set(PatResult311,'String',strcat(sprintf('%0.2f',ASMM),'kg'));
        MMass = ASMM;
        set(PatResult322,'String',strcat(sprintf('%0.2f',ASMM*100/Weight),'%'));
        MMassPrW = ASMM*100/Weight;
        set(PatResult333,'String',strcat(sprintf('%0.2f',RDEE),'kcal'));
        
        set(BIVAPie,'Visible','on');
        set(BCAlert,'Visible','off');
        set(BC,'Visible','on');
        Other = Weight-ECW-ICW-FM;
        xpie = [ECW,ICW,FM,Other];
        labelspie = {strcat((sprintf('%0.2f',ECW)),sprintf('kg\n'),sprintf('\nExtracellular\nWater')),strcat((sprintf('%0.2f',ICW)),sprintf('kg'),sprintf('\nIntracellular\nWater')),strcat((sprintf('%0.2f',FM)),sprintf('kg'),sprintf('\nFat mass')),sprintf('Other\n(Bone, tissue)')};
        pie3(BIVAPie,xpie,labelspie );
        %BIVAPie.Title.String = ('Body Composition');
        x = [BMI,BMI];
        y =[0,1];
        
        plot(Param1,x,y,'red','LineWidth',10);
        Param1.XLim = [8 55];
        Param1.YTick = '';
        Param1.YColor = [1 1 1];
        box on;
        
        x = [(Weight-FFM)*100/Weight,(Weight-FFM)*100/Weight];
        y =[0,1];
        plot(Param2,x,y,'red','LineWidth',10);
        Param2.XLim = [8 55];
        Param2.YTick = '';
        Param2.YColor = [1 1 1];
        box on;
        
        checkBCA = 1;
        FatCorrection ();
        BIVAPlot();
        
    end

    function AnalysisECG()
        clearvars ECG IPG indR RRI PAT_SSF;
        PRADZIA = 0;
        % Analysis1
        ECG = ECG_SIGNAL_USED(PRADZIA+(Fs(2)*6):end);
        IPG = -data2(PRADZIA+(Fs(2)*6):end,6);
        [ECG, delayECG]=fun_ECG_processing_v2_noplot_p(ECG, Fs(2)); %filtravimas ECG
        [IPG, delayIPG]=fun_IPG_differentiator_noplot_p(IPG, Fs(2)); %filtravimas ir diferencijvimas IPG
        ECG=ECG(delayIPG-delayECG+1:end-(delayIPG-delayECG)); %sukompensuot velinimus
        [rIndex,rr]=qrs_slenkstis_p(ECG,1000,0.6,0.25);
        try
            [indR,RRI,ECG,absECG, delayECG2,time]=fun_R_detect_threshold_v2_noplot_p(ECG, Fs(2));
            %[rIndex,rr,ECG,absECG, delayECG2,time]=fun_R_detect_threshold_v2_noplot(ECG, Fs(2));
        catch
            disp('error, signal not good enough');
            return;
        end
        
%         r1 = RRI
%         r2 = rr
%         figure
%         plot(RRI);
%         figure
%         plot(rr);
%         
%         HRCycleAF1 = (60*Fs(2))./(RRI)
%         HRCycleAF2 = (60*Fs(2))./(rr)
%         figure
%         plot((1:max(size(HRCycleAF1))),HRCycleAF1,(1:max(size(HRCycleAF2))),HRCycleAF2)
         
        rIndex = indR;
        IPG=IPG(delayECG2+1:end-delayECG2); %sukompensuot velinimus
        [PAT_SSF, SSF,indS]=fun_SSF_PAT_estimation_v2_noplot_p(rIndex, IPG, Fs(2));
        
        PAT_SSF=1000*PAT_SSF;
        
        %         Image
        axes(image4)
        matlabImage = imread(strcat(pwd,'/Pictures/PWv2.PNG'));
        image(matlabImage)
        axis off
        axis image
        set(Analysis1,'Visible','off');
        
        image4.Color(4)=0.1;
        uistack(axPWV,'top');
    end

    function PlotArterialStiffness()
        cla(axan1,'reset');
        cla(axan2,'reset');
        cla(axPWV,'reset');
        
        ph=findall(axPWV,'type','patch');
        set(ph,'FaceColor','none')
        
        set(ASAge,'String',num2str(Age));
        set(ASHeight,'String',num2str(Height));
        set(ASPEP,'String',num2str(PEPtime));
        
        HRCycle = (60*Fs(2))./(RRI);
        HRCycle_length = 1:length(HRCycle);
        hold(axan1,'on');
        box(axan1,'on');
        plot(axan1,HRCycle_length,HRCycle);
        hold(axan1,'off');
        axan1.YLim = [min(HRCycle) max(HRCycle)];
        axan1.XLim = [min(HRCycle_length) max(HRCycle_length)];
        %axan1.XLabel.String = ('Heart Rate Cycle');
        axan1.YLabel.String = ('Heart Rate, Bpm');
        title(axan1,'Heart Rate', 'FontSize', 12);
        
        MedianPAT = median(PAT_SSF);
        MeanPAT = mean(PAT_SSF);
        STDPAT = std(PAT_SSF);
        
        PAT_SSF_length=1:length(PAT_SSF);
        hold(axan2,'on');
        box(axan2,'on');
        plot(axan2,PAT_SSF_length,PAT_SSF);
        Medarray = zeros(1,length(PAT_SSF_length)) + MedianPAT;
        plot(axan2,PAT_SSF_length,Medarray,'r','LineWidth',1);
        Meanarray = zeros(1,length(PAT_SSF_length)) + MeanPAT;
        plot(axan2,PAT_SSF_length,Meanarray,'b','LineWidth',1);
        STDParray = zeros(1,length(PAT_SSF_length)) + MeanPAT + STDPAT;
        plot(axan2,PAT_SSF_length,STDParray,'-.r');
        STDMarray = zeros(1,length(PAT_SSF_length)) + MeanPAT - STDPAT;
        plot(axan2,PAT_SSF_length,STDMarray,'-.r');
        hold(axan2,'off');
        
        axan2.YLim = [min(PAT_SSF) max(PAT_SSF)];
        axan2.XLim = [min(PAT_SSF_length) max(PAT_SSF_length)];
        axan2.XLabel.String = ('Heart Rate cycle');
        axan2.YLabel.String = ('Pulse Arrival Time, ms');
        title(axan2,'Pulse Arrival Time', 'FontSize', 12);
        if PEPtime > 20
            peptimemin = PEPtime - 20;
        else
            peptimemin = PEPtime;  
        end
            peptimemax = PEPtime + 20;
        timepat = MeanPAT-PEPtime;
        timepatmin = MeanPAT-peptimemin;
        timepatmax = MeanPAT-peptimemax;
        heightpat = Height;
        speedpat = (((12/15)*heightpat)/100)/(timepat/1000);
        speedpat1 = (((12/15)*heightpat)/100)/(timepatmin/1000);
        speedpat2 = (((12/15)*heightpat)/100)/(timepatmax/1000);
        if isempty(Age)
            Age1 = 35;
        else
            Age1 = Age;
            
        end
        plot(axPWV,Age1,speedpat,'r.','MarkerSize',40)
        uistack(axPWV,'top');
        axPWV.Color(4)=0.3;
        axPWV.XLabel.String = ('Age, years');
        
        axPWV.XLim = [20 100];
        axPWV.YLim = [4 22];
        
        set(axPWV,'FontSize',7);
        
        set(axan1,'FontSize',7);
        set(axan2,'FontSize',7);
        cnames1 = {'Value','Units'};
        rnames1 = {'Mean','Median','STD+-','Velocity'};
        dataECG = [sprintf('%0.1f',round(MeanPAT,1)),cellstr('ms');sprintf('%0.1f',round(MedianPAT,1)),cellstr('ms');sprintf('%0.1f',round(STDPAT,1)),cellstr('ms');sprintf('%0.1f',round(speedpat,1)),cellstr('m/s')];
        % Table
        %     TableECGAn = uitable(Analysis1,'Data',dataECG,'ColumnName',cnames1,'RowName',rnames1);
        %     TableECGAn.Position(3) = 240;
        %     TableECGAn.Position(4) = TableECGAn.Extent(4);
        %     TableECGAn.Position(1) = 820;
        %     TableECGAn.Position(2) = 130;
        uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','bold','FontSize',9,'String',sprintf('%0.1f',round(MeanPAT,1)),'Units','Pixels','Position',[855 ASwindowheight-265 40 18],'BackGroundColor',Backgroundcolor);
        uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','bold','FontSize',9,'String',sprintf('%0.1f',round(MedianPAT,1)),'Units','Pixels','Position',[855 ASwindowheight-295 40 18],'BackGroundColor',Backgroundcolor);
        uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','bold','FontSize',9,'String',sprintf('%0.1f',round(STDPAT,1)),'Units','Pixels','Position',[855 ASwindowheight-325 40 18],'BackGroundColor',Backgroundcolor);
        uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','bold','FontSize',9,'String',sprintf('%0.1f',round(speedpat1,1)),'Units','Pixels','Position',[855 ASwindowheight-355 20 18],'BackGroundColor',Backgroundcolor);
        uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','bold','FontSize',9,'String',sprintf('%0.1f',round(speedpat2,1)),'Units','Pixels','Position',[895 ASwindowheight-355 20 18],'BackGroundColor',Backgroundcolor);
        uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','bold','FontSize',9,'String','-','Units','Pixels','Position',[883 ASwindowheight-355 5 18],'BackGroundColor',Backgroundcolor);
        
        
        % 
        %uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','bold','FontSize',9,'String','-','Units','Pixels','Position',[895 ASwindowheight-400 20 18],'BackGroundColor',Backgroundcolor);
        %uicontrol('Parent',Analysis1,'Style','text','HorizontalAlignment','left','FontWeight','bold','FontSize',9,'String','-','Units','Pixels','Position',[883 ASwindowheight-420 5 18],'BackGroundColor',Backgroundcolor);
        
        
        checkECG = 1;
        clearvars Medarray Meanarray STDParray;
        set(Analysis1,'Visible','on');
    end

    function AFAnalysis()
        
        for i = 3:5
            % Resample to 1000 Hz
            ECG = BACKUP_DATA(:,i);
            ECG = ECG/std(ECG);
            
            % High pass filtering
            h  = fdesign.highpass('N,F3dB', 2, 0.5, 1000);
            Hd = design(h, 'butter');
            
            % Warning isjungimas
            MSGID = 'signal:filtfilt:ParseSOS';
            warning('off', MSGID)
            
            ECG = filtfilt(Hd.sosMatrix,Hd.ScaleValues,ECG);
            
            
            % QRS detection
            [rIndex,rr]=qrs_slenkstis_p(ECG,1000,0.6,0.25);
            rIndex = rIndex(1:end-1);
            rIndexi = rIndex(1:end-1);
            HRCycleAF = (60*Fs(2))./(rr);
            % AF detection
            [R, Rthr] = func_LowComplexityDetector_p(rr/1000, 0.1, 0.725);
            
            switch i
                case 3
                    Rthr1 = Rthr;
                    Rthr1size = max(size(Rthr1));
                case 4
                    Rthr2 = Rthr;
                    Rthr2size = max(size(Rthr2));
                case 5
                    Rthr3 = Rthr;
                    Rthr3size = max(size(Rthr3));
            end
            if sum(Rthr) > 2*length(Rthr)/3
                AF = AF + 1;
            end
            
        end
        
        minRthrsize = min([Rthr1size Rthr2size Rthr3size]);
        Rthr = Rthr1(1:minRthrsize) .* Rthr2(1:minRthrsize) .* Rthr3(1:minRthrsize);
        if AF ==3
            %         set(AFResultText,'String','AF detected');
            %         set(AFResultText,'ForegroundColor','red');
            axes(image3)
            CheckImage = imread(strcat(pwd,'/Pictures/Delete-120.jpg'));
            image(CheckImage)
            axis off
            axis image
            
            set(ButtonAF,'String','Atrial Fibrilation is suspected');
            set(ButtonAF,'BackGroundColor',[1 0.7 0.7]);
        else
            %         set(AFResultText,'String','AF not detected');
            %         set(AFResultText,'ForegroundColor','black');
            axes(image3)
            CheckImage = imread(strcat(pwd,'/Pictures/Checkmark-120.jpg'));
            image(CheckImage)
            axis off
            axis image
            
            set(ButtonAF,'String','Atrial Fibrilation is not found');
            set(ButtonAF,'BackGroundColor',[0.7 1 0.7]);
        end
        PlotAFAnalysis();
        
    end

    function PlotAFAnalysis()
        
        cla(axan22,'reset');
        
        ecgTimeAF = 1:length(DATA_PP(: ,3));
        deltax = SliderValAF;
        lengthAF = max(rIndex);
        lengthAFshown = lengthAF/10;
        leftAFsignal = lengthAF-lengthAFshown;
        AFsignalTick = leftAFsignal/100;
        placeAFSignal = AFsignalTick * deltax;
        
        
        
        all1 = lengthAF/500;
        rrnr = length(HRCycleAF)-3;
        
        prop = rrnr/all1;
        
        hrAFmean = mean(HRCycleAF);
        hrAFMax = max(HRCycleAF);
        hrAFMin = min(HRCycleAF);
        
        set(AFResult1,'String',num2str(round(hrAFmean)));
        set(AFResult2,'String',num2str(round(hrAFMax)));
        set(AFResult3,'String',num2str(round(hrAFMin)));
        
        nrreal1 = round(((0+(placeAFSignal))/500)*prop);
        if nrreal1<1
            nrreal1 = 1;
        end
        nrreal2 = round(((lengthAFshown+placeAFSignal+2000)/500)*prop)-2;
        if nrreal2>max(length(HRCycleAF))
            nrreal1 = max(length(HRCycleAF));
        end
        
        % Signalu sudejimas
        sigvid = DATA_PP(: ,4);
        maxvid = max(sigvid(4000:6000));
        minvid = min(sigvid(4000:6000));
        diffvid = abs(maxvid) + abs(minvid);
        
        textpos = diffvid+((maxvid/4)*5);
        
        plot(axan11,ecgTimeAF/500,DATA_PP(: ,4),ecgTimeAF/500,(DATA_PP(: ,5)-diffvid),ecgTimeAF/500,(DATA_PP(: ,3)+diffvid),'Color',[0 0 0]);
        % hold on;
        % plot(axan11,ecgTimeAF/500,(DATA_PP(: ,5)-diffvid));
        % hold on;
        % plot(axan11,ecgTimeAF/500,(DATA_PP(: ,3)+diffvid));
        hold on;
        sig = DATA_PP(: ,3);
        nrheight = max(sig(6000:end));
        % specific_grid(-500:100:15000, -5:0.1:40, [1 0.8 0.8], 0.1)
        % specific_grid(-500:500:15000, -5:0.5:40, [1 0.5 0.5], 0.2)
        
        % g_x = -0.0015:0.00001:0.005;
        % g_y = -5:0.1:40;
        % clr = [1 0.8 0.8];
        % LineWidth = 0.1;
        %     for iii=1:length(g_x)
        %         plot(axan11,[g_x(i) g_x(i)],[g_y(1) g_y(end)],'Color', clr, 'LineWidth', LineWidth) %y grid lines
        %         hold(axan11,'on');
        %     end
        %     for iii=1:length(g_y)
        %         plot(axan11,[g_x(1) g_x(end)],[g_y(i) g_y(i)],'Color', clr, 'LineWidth', LineWidth) %x grid lines
        %     end
        topsignal = DATA_PP(: ,3);
%         MaxECGHeight = max(topsignal(4000:6000))+diffvid;
        MaxECGHeight = max(topsignal(round(500+placeAFSignal): round(lengthAFshown+placeAFSignal)))+(diffvid*(2/3));
        for ii = nrreal1:nrreal2
            
            txt1 = sprintf('%d',round(HRCycleAF(ii)));
            %text((rIndex(ii)/500)+((rr(ii)/500)*(2/5)),textpos,txt1,'Parent',axan11);(
            text((rIndex(ii)/500)+((rr(ii)/500)*(2/5)),MaxECGHeight,txt1,'Parent',axan11);
            hold(axan11,'on');
        end
        uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','10mm/s, 2mm/mv','Units','Pixels','Position',[70, 150, 100, 15],'BackGroundColor',Backgroundcolor);
        uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','Position',[60, 503, 750, 15],'BackGroundColor',[0.9 1 0.9]);
        
        uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','Position',[00, 460, 55, 30],'BackGroundColor',Backgroundcolor);
        
        uicontrol('Parent',Analysis2,'Style','text','HorizontalAlignment','left','FontWeight','normal','String','','Units','Pixels','FontSize',11,'Position',[830, 390, 200, 200],'BackGroundColor',Backgroundcolor);
        hold(axan11,'off');
        
        axan11.XLim = [round(500+placeAFSignal)/500 round(lengthAFshown+placeAFSignal)/500];
        axan11.YTickLabel = '';
        axan11.YTick = -10/1000000:1/1000000:10/1000000;
        axan11.XTick = 0:1:100;
        
        axan11.XGrid = 'on';
        axan11.YGrid = 'on';
        axan11.XMinorGrid = 'on';
        axan11.YMinorGrid = 'on';
        axan11.GridColor = [1 0.1 0.1];
        axan11.MinorGridColor = [1 0.9 0.9];
        axan11.LineWidth = 0.3;
        axan11.MinorGridLineStyle = '-';
        
        
        hold(axan22,'on')
        patch([0 round(0+placeAFSignal)/500 round(0+placeAFSignal)/500 0],[-1 -1 1 1],[0.8 1 0.8],'Parent', axan22,'FaceAlpha',0.5,'EdgeColor',[1 1 1])
        patch([round(0+placeAFSignal)/500 round(lengthAFshown+placeAFSignal)/500 round(lengthAFshown+placeAFSignal)/500 round(0+placeAFSignal)/500],[-1 -1 1 1],[0.4 1 0.4],'Parent', axan22,'FaceAlpha',0.5,'EdgeColor',[1 1 1])
        patch([round(lengthAFshown+placeAFSignal)/500 max(rIndex)/500 max(rIndex)/500 round(lengthAFshown+placeAFSignal)/500],[-1 -1 1 1],[0.8 1 0.8],'Parent', axan22,'FaceAlpha',0.5,'EdgeColor',[1 1 1])
        %plot(axan22,rIndex/500,R, 'b')
        plot(axan22,rIndex(1:minRthrsize)/500,Rthr, 'r','LineWidth',2)
        axan22.XLim = [0 max(rIndex)/500];
        axan22.YLim = [-0.05 1.05];
        hold(axan22,'off')
        axan22.XLabel.String = ('Time, s');
        axan22.YTick = '';
        axan22.YColor = [1 1 1];
        
        % box(axan31,'off');
        box(axan11,'on');
        % set(axan31,'FontSize',7);
        set(axan11,'FontSize',7);
        % set(axan21,'FontSize',7);
        set(axan22,'FontSize',7);
        
        
    end

    function SignalComparePlot()
        deltax = SliderValComp2;
        SigTimeComp = 1:length(DATA_PP_MAIN(: ,3));
        deltaheight1 = SliderValComp3;
        deltaheight2 = SliderValComp4;
        Graph_Signal_Comp1 = DATA_PP(: ,CompareSignal1);
        Graph_Signal_Comp2 = DATA_PP(: ,CompareSignal2);
        axcomp1.Color(4)=0.3;
        axcomp2.Color(4)=0.3;
        lengthCompshown = length(Graph_Signal_Comp1)/XSliderTick;
        leftCompsignal = length(Graph_Signal_Comp1)-lengthCompshown;
        CompsignalTick = leftCompsignal/100;
        placeCompSignal = CompsignalTick * deltax;
        plot(axcomp1,SigTimeComp/500,Graph_Signal_Comp1);
        plot(axcomp2,SigTimeComp/500,Graph_Signal_Comp2,'r');
        box(axcomp1,'off');
        box(axcomp2,'off');
        axcomp2.XTick = '';
        axcomp2.XColor = [1 1 1];
        max1Comp = max(Graph_Signal_Comp1(20000:22000));
        max2Comp = max(Graph_Signal_Comp2(20000:22000));
        axcomp2.YAxisLocation = 'right';
        maxComp = max(max1Comp,max2Comp);
        
        min1Comp = min(Graph_Signal_Comp1(20000:22000));
        min2Comp = min(Graph_Signal_Comp2(20000:22000));
        
        minComp = min(min1Comp,min2Comp);
        maxminval1 = max(abs(maxComp), abs(minComp));
        maxminval2 = max(abs(maxComp), abs(minComp));
        normDeltaheight1 = (((maxminval1)/100)*(deltaheight1-1));
        normDeltaheight2 = (((maxminval1)/100)*(deltaheight2-1));
        axcomp1.XLim=([round(0+placeCompSignal)/500 round(lengthCompshown+placeCompSignal)/500]);
        axcomp2.XLim=([round(0+placeCompSignal)/500 round(lengthCompshown+placeCompSignal)/500]);
        axcomp1.YLim=([(-maxminval1+normDeltaheight2) (maxminval1-normDeltaheight2)]);
        axcomp2.YLim=([(-maxminval2+normDeltaheight1) (maxminval2-normDeltaheight1)]);
    end

    function [BestSigNr, pol]=  SkewnessAnalysis()
        lp = 40;
        hp = 0.67;
        DATA_ECG_CH1 = ECGfilterCARRE(DATA_ECG_CH1_RR, lp, hp);
        DATA_ECG_CH2 = ECGfilterCARRE(DATA_ECG_CH2_RR, lp, hp);
        DATA_ECG_CH3 = ECGfilterCARRE(DATA_ECG_CH3_RR, lp, hp);
        
        for o = 1:3
            switch o
                case 1
                    Channel = DATA_ECG_CH1;
                case 2
                    Channel = DATA_ECG_CH2;
                case 3
                    Channel = DATA_ECG_CH3;
            end
            
            
            sumECGup = 0;
            sumECGdown = 0;
            meanChannel = mean(Channel);
            for i = 1:length(Channel)
                ECGval1(i) = ((Channel(i)-meanChannel)^3);
                ECGval2(i) = ((Channel(i)-meanChannel)^2);
                sumECGup = sumECGup + ECGval1(i);
                sumECGdown = sumECGdown + ECGval2(i);
            end
            
            meanSumUp = sumECGup/length(Channel);
            meanSumDown = sumECGdown/(length(Channel)-1);
            
            skew = meanSumUp/(meanSumDown^(3/2));
            
            switch o
                case 1
                    skew1abs = abs(skew);
                    skew1 = skew;
                    %             disp('CH1');
                    %             disp(skew);
                case 2
                    skew2abs = abs(skew);
                    skew2 = skew;
                    %             disp('CH2');
                    %             disp(skew);
                case 3
                    skew3abs = abs(skew);
                    skew3 = skew;
                    %             disp('CH3');
                    %             disp(skew);
            end
        end
        
        if skew1abs>=skew2abs && skew1abs>=skew3abs
            set(TextAS2,'String','ECG Lead I');
            BestSigNr = 1;
            if skew1 > 0
                pol = 1;
            else
                pol = 0;
            end
        elseif skew2abs>=skew1abs && skew2abs>=skew3abs
            set(TextAS2,'String','ECG Lead II');
            BestSigNr = 2;
            if skew2 > 0
                pol = 1;
            else
                pol = 0;
            end
        elseif skew3abs>=skew2abs && skew3abs>=skew1abs
            set(TextAS2,'String','ECG Lead III');
            BestSigNr = 3;
            if skew3 > 0
                pol = 1;
            else
                pol = 0;
            end
        else
            BestSigNr = 1;
            pol = 1;
        end
    end

    function BIVAPlot()
        
        cla(BIVAaxis,'reset')
        Resistance1 = ((Z(4,BivaState) * cos(deg2rad(Fi(4,BivaState)))) *100)/Height;
        Reactance1  = ((Z(4,BivaState) * sin(deg2rad(Fi(4,BivaState)))) *100)/Height;
        hold(BIVAaxis,'on');
        
        if Sexnr==1
            plot(BIVAaxis,Male50X,Male50Y,Male75X,Male75Y,Male95X,Male95Y);
            text(380,60,'Dehidrated','Parent',BIVAaxis);
            text(200,26,'Hyper-hidrated','Parent',BIVAaxis);
            text(360,32,sprintf('Body cell\n Mass decrease'),'Parent',BIVAaxis);
            text(220,53,sprintf('Body cell\n Mass increase'),'Parent',BIVAaxis);
        else
            plot(BIVAaxis,Female50X,Female50Y,Female75X,Female75Y,Female95X,Female95Y);
            text(440,65,'Dehidrated','Parent',BIVAaxis);
            text(250,25,'Hyper-hidrated','Parent',BIVAaxis);
            text(440,32,sprintf('Body cell\n Mass decrease'),'Parent',BIVAaxis);
            text(250,58,sprintf('Body cell\n Mass increase'),'Parent',BIVAaxis);
        end
        plot(BIVAaxis,Resistance1,Reactance1,'or','LineWidth',3)
        box(BIVAaxis,'off');
        hold(BIVAaxis,'off');
        set(BIVAaxis,'FontSize',graphfontsize+3);
        BIVAaxis.XLabel.String = 'Reactance';
        BIVAaxis.YLabel.String = 'Resistance';
    end

    function FatCorrection()
        
        if Sexnr == 1
            if Age<=39
                set(Param2,'xlim',[0 40]);
                Param2.XLim = [0 40];
                % 0-40 15/1%
                set(FatUnder,'Position',[300 570 120 20]);
                set(FatHealt,'Position',[420 570 165 20]);
                set(FatOverf,'Position',[585 570 90 20]);
                set(FatObese,'Position',[675 570 225 20]);
                set(FatMass1,'String','8 - 19 %');
                set(FatFreeMass1,'String','81 - 92 %');
                FM1 = 8;
                FM2 = 19;
                FFM1 = 81;
                FFM2 = 92;
            elseif Age<=59 && Age>39
                set(Param2,'xlim',[0 40]);
                Param2.XLim = [0 40];
                % 0-40 15/1%
                set(FatUnder,'Position',[300 570 165 20]);
                set(FatHealt,'Position',[465 570 165 20]);
                set(FatOverf,'Position',[630 570 90 20]);
                set(FatObese,'Position',[720 570 180 20]);
                set(FatMass1,'String','11 - 22 %');
                set(FatFreeMass1,'String','78 - 89 %');
                FM1 = 11;
                FM2 = 22;
                FFM1 = 78;
                FFM2 = 89;
            else
                set(Param2,'xlim',[0 40]);
                Param2.XLim = [0 40];
                % 0-40 15/1%
                set(FatUnder,'Position',[300 570 195 20]);
                set(FatHealt,'Position',[495 570 180 20]);
                set(FatOverf,'Position',[675 570 75 20]);
                set(FatObese,'Position',[750 570 150 20]);
                set(FatMass1,'String','13 - 25 %');
                set(FatFreeMass1,'String','75 - 87 %');
                FM1 = 13;
                FM2 = 25;
                FFM1 = 75;
                FFM2 = 87;
            end
        elseif Sexnr == 0
            if Age<=39
                set(Param2,'xlim',[10 50]);
                Param2.XLim = [10 50];
                % 10-50 15/1%
                set(FatUnder,'Position',[300 570 165 20]);
                set(FatHealt,'Position',[465 570 180 20]);
                set(FatOverf,'Position',[645 570 90 20]);
                set(FatObese,'Position',[735 570 165 20]);
                set(FatMass1,'String','21 - 33 %');
                set(FatFreeMass1,'String','67 - 79 %');
                FM1 = 21;
                FM2 = 33;
                FFM1 = 67;
                FFM2 = 79;
            elseif Age<=59 && Age>39
                set(Param2,'xlim',[10 50]);
                Param2.XLim = [10 50];
                % 10-50 15/1%
                set(FatUnder,'Position',[300 570 195 20]);
                set(FatHealt,'Position',[495 570 180 20]);
                set(FatOverf,'Position',[675 570 75 20]);
                set(FatObese,'Position',[750 570 150 20]);
                set(FatMass1,'String','23 - 35 %');
                set(FatFreeMass1,'String','65 - 77 %');
                FM1 = 23;
                FM2 = 35;
                FFM1 = 65;
                FFM2 = 77;
            else
                set(Param2,'xlim',[10 50]);
                Param2.XLim = [10 50];
                % 10-50 15/1%
                set(FatUnder,'Position',[300 570 210 20]);
                set(FatHealt,'Position',[510 570 180 20]);
                set(FatOverf,'Position',[690 570 90 20]);
                set(FatObese,'Position',[780 570 120 20]);
                set(FatMass1,'String','24 - 36 %');
                set(FatFreeMass1,'String','64 - 76 %');
                FM1 = 24;
                FM2 = 36;
                FFM1 = 64;
                FFM2 = 76;
            end
        end
        
    end
%% Close functions
    function closeAnalysis1(src, evnt, handles)
        
        set(Analysis1,'Visible','off');
        
    end

    function closeAnalysis2(src, evnt, handles)
        
        set(Analysis2,'Visible','off');
        
    end

    function closeParameters(src, evnt, handles)
        
        set(BCA,'Visible','off');
        
    end

    function closeHRV(src, evnt, handles)
        
        set(HRVFigure,'Visible','off');
        
    end

    function closeSigCompare(src, evnt, handles)
        
        set(SigCompare,'Visible','off');
        
    end

    function closeMain(src, evnt, handles)
        delete(Analysis1);
        delete(Analysis2);
        delete(BCA);
        delete(HRVFigure);
        delete(SigCompare);
        close(h);
    end

    function closeSavedData(src, evnt, handles)
        
        set(SavedData,'Visible','off');
        
    end

    function closeSaveParametersData(src, evnt, handles)
        
        set(SaveParametersData,'Visible','off');
        
    end

    function closePrintFile(src, evnt, handles)
        
        set(PrintFile,'Visible','off');
        
    end
%% TB Callbacks
    function TBCallbackPatientNameResEdit(hObject, eventdata, handles)
        PatientName = get(hObject,'String');
        set(PatientNameResEdit,'Visible','off');
        set(PatientNameRes,'String',PatientName);
        
    end

    function TBCallbackPatientNameSaveDataEdit(hObject, eventdata, handles)
        PatientName = get(hObject,'String');
        set(PatientNameResEdit,'Visible','off');
        set(PatientNameRes,'String',PatientName);
        
    end

    function TBCallbackPatientDateSaveDataEdit(hObject, eventdata, handles)
        MeasureDate = get(hObject,'String');
    end

    function TBASAgeCallback(hObject, eventdata, handles)
        Age = str2double(get(hObject,'String'));
        PlotArterialStiffness();
    end

    function TBASHeightCallback(hObject, eventdata, handles)
        Height = str2double(get(hObject,'String'));
        PlotArterialStiffness();
    end

    function TBASPEPCallback(hObject, eventdata, handles)
        PEPtime = str2double(get(hObject,'String'));
        PlotArterialStiffness();
    end

%% Toolabars
    function hZoomInMenuitemCallback(hObject, eventdata)
        if zoomcheck == 0
            zoom on;
            zoomcheck = 1;
        else
            zoom off;
            zoomcheck = 0;
        end
    end

    function hZoomOutMenuitemCallback(hObject, eventdata)
        if zoomcheck == 0
            zoom out;
            zoomcheck = 1;
        else
            zoom off;
            zoomcheck = 0;
        end
    end

%% Safety functions
    function checkboxenable()
        set(CheckBoxW1,'Enable','on');
        set(CheckBoxW2,'Enable','on');
        set(CheckBoxW3,'Enable','on');
        set(CheckBoxW4,'Enable','on');
        set(CheckBoxW5,'Enable','on');
        set(CheckBoxW6,'Enable','on');
        set(CheckBoxW7,'Enable','on');
        set(CheckBoxW8,'Enable','on');
        set(CheckBoxW9,'Enable','on');
        set(CheckBoxW10,'Enable','on');
    end

    function checkboxdisable()
        set(CheckBoxW1,'Enable','off');
        set(CheckBoxW2,'Enable','off');
        set(CheckBoxW3,'Enable','off');
        set(CheckBoxW4,'Enable','off');
        set(CheckBoxW5,'Enable','off');
        set(CheckBoxW6,'Enable','off');
        set(CheckBoxW7,'Enable','off');
        set(CheckBoxW8,'Enable','off');
        set(CheckBoxW9,'Enable','off');
        set(CheckBoxW10,'Enable','off');
    end

    function ctrlbuttonenable()
        set(Button1,'Enable','on');
        set(Button2,'Enable','on');
        set(Button3,'Enable','on');
        set(Button4,'Enable','on');
    end

    function ctrlbuttondisable()
        set(Button1,'Enable','off');
        set(Button2,'Enable','off');
        set(Button3,'Enable','off');
        set(Button4,'Enable','off');
    end

end